# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import subprocess
import os
import sys
import glob

def getGrep(tid, fold):
    if tid==3:
        if fold==1:
            return 'q201-210.10.*q151-200'
        if fold==2:
            return 'q211-220.10.*q151-200'
        if fold==3:
            return 'q221-230.10.*q151-200'
        if fold==4:
            return 'q231-240.10.*q151-200'
        if fold==5:
            return 'q241-250.10.*q151-200'

    if tid==7:
        if fold==1:
            return 'q401-410.10.*q351-400'
        if fold==2:
            return 'q411-420.10.*q351-400'
        if fold==3:
            return 'q421-430.10.*q351-400'
        if fold==4:
            return 'q431-440.10.*q351-400'
        if fold==5:
            return 'q441-450.10.*q351-400'

    if tid==9:
        if fold==1:
            return 'q501-510.10.*q451-500'
        if fold==2:
            return 'q511-520.10.*q451-500'
        if fold==3:
            return 'q521-530.10.*q451-500'
        if fold==4:
            return 'q531-540.10.*q451-500'
        if fold==5:
            return 'q541-550.10.*q451-500'

    if tid==11:
        if fold==1:
            return 'q601-610.10.*q551-600'
        if fold==2:
            return 'q611-620.10.*q551-600'
        if fold==3:
            return 'q621-630.10.*q551-600'
        if fold==4:
            return 'q631-640.10.*q551-600'
        if fold==5:
            return 'q641-650.10.*q551-600'

    if tid==35:
        if fold==1:
            return 'q301-310.10.*q151-300'
        if fold==2:
            return 'q311-320.10.*q151-300'
        if fold==3:
            return 'q321-330.10.*q151-300'
        if fold==4:
            return 'q331-340.10.*q151-300'
        if fold==5:
            return 'q341-350.10.*q151-300'

    if tid==37:
        if fold==1:
            return 'q401-410.10.*q151-400'
        if fold==2:
            return 'q411-420.10.*q151-400'
        if fold==3:
            return 'q421-430.10.*q151-400'
        if fold==4:
            return 'q431-440.10.*q151-400'
        if fold==5:
            return 'q441-450.10.*q151-400'

    if tid==39:
        if fold==1:
            return 'q501-510.10.*q151-500'
        if fold==2:
            return 'q511-520.10.*q151-500'
        if fold==3:
            return 'q521-530.10.*q151-500'
        if fold==4:
            return 'q531-540.10.*q151-500'
        if fold==5:
            return 'q541-550.10.*q151-500'

def getFbdocs(tid):
    if tid==3:
        return [160,170,180,190,200]
        return [180]
    if tid==7:
        return [120,130,140,150,160,170,180,190,200]
        return [140]
    if tid==9:
        return [180,190,200,250,300,400,500]
        return [300]
    if tid==11:
        return [300,400,500,600,700]
        return [500]
    if tid==35:
        return [160,170,180,190,200,250,300,400,500]
        return [200]
    if tid==37:
        return [120,130,140,150,160,170,180,190,200]
        return [140]
    if tid==39:
        return [120,130,140,150,160,170,180,190,200,250,300]
        return [140, 150, 160]
        return [150]

def getTest(tid):
    if tid==35:
        return 6
    if tid==37:
        return 8
    if tid==39:
        return 10
    else:
        return tid+1


def getBaseline(tid):
    if tid==3:
        return 0.1964
    if tid==7:
        return 0.2241
    if tid==9:
        return 0.1638
    if tid==11:
        return 0.0603
    if tid==35:
        return 0.1795
    if tid==37:
        return 0.2241
    if tid==39:
        return 0.1638

def getLe(tid):
    if tid==3:
        return 0.2073
    if tid==7:
        return 0.2291
    if tid==9:
        return 0.1799
    if tid==11:
        return 0.0612
    if tid==35:
        return 0.1980
    if tid==37:
        return 0.2228
    if tid==39:
        return 0.1690

def getZ(tid):
    if tid==3:
        return 0.2010
    if tid==7:
        return 0.2239
    if tid==9:
        return 0.1783
    if tid==11:
        return 0.0580
    if tid==35:
        return 0.1915
    if tid==37:
        return 0.2152
    if tid==39:
        return 0.1772


if(len(sys.argv) !=3):
    print 'Usage: %s <resfile> <resdir>'%(sys.argv[0])
    exit(1)
    
resfile = sys.argv[1]
resdir = sys.argv[2]

#for tid in [3,7,9,11,35,37,39]:
for tid in [3,35,7,37,9,39,11]:
    testid =  getTest(tid)
    print '%d:'%tid
    fbdocs = getFbdocs(tid)
    avg_map = 0
    outputres= '%s/t%d.res' %(resdir, tid)
    os.system('echo \'\' > %s' % (outputres))
    for fold in [1,2,3,4,5]:
        grepstr = getGrep(tid, fold)
        grepoutput = subprocess.check_output(('grep %s %s' %(grepstr, resfile)).split(' '))
        lines = grepoutput.strip().split('\n')
        best_cv_err = 10000000
        best_fbdoc = None
        corr_test_err = 10000000
        corr_test_map = -1
        corr_test_res = None

        for line in lines:
            fbdoc = int(line.split('fbdoc')[1].split('.')[0])
            if fbdoc not in fbdocs:
                continue
            parts = line.split('\t')
            cv_err = float(parts[6])
            test_err = float(parts[7])
            test_map = float(parts[4])

            if cv_err < best_cv_err:
                best_cv_err = cv_err
                best_fbdoc = fbdoc
                corr_test_map = test_map
                corr_test_res ='%s/%s.res' %(resdir, parts[2].split('/')[-1])

        #print best_cv_map, corr_test_map, best_fbdoc
        avg_map = avg_map + corr_test_map
        os.system('cat %s >> %s' %(corr_test_res, outputres))        
        
    evaloutput = subprocess.check_output(('./trec_eval ../qrels/qrels.t%d.txt %s' %(testid, outputres)).split(' '))
    eval_map = float(evaloutput.strip().split('\n')[5].split('\t')[-1])
    baseline = getBaseline(tid)
    le = getLe(tid)
    zgq = getZ(tid)
    print 'Baseline: %f AVG: %f REAL: %f' %(baseline, avg_map / 5, eval_map)
    print 'Impovement over baseline: %f'%((eval_map -baseline)/baseline)
    print 'Absolute change over Le: %f'%(eval_map-le)
    print 'Absolute change over Zgq: %f' %(eval_map-zgq)
        



