# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import sys
import os

if __name__ == '__main__':
    if len(sys.argv)!=3:
        print 'Usage: %s model1.gdeval model2.gdeval ' % sys.argv[0]
        exit(0)

    with open('bootstrap_gdeval.tmp.ndcg', 'w') as w1, open('bootstrap_gdeval.tmp.err', 'w') as w2:
        w1.write('%s\t%s\n' % (sys.argv[1].split('/')[-1], sys.argv[2].split('/')[-1]))
        w2.write('%s\t%s\n' % (sys.argv[1].split('/')[-1], sys.argv[2].split('/')[-1]))
        with open(sys.argv[1], 'r') as f1,  open(sys.argv[2], 'r') as f2:
            for line in zip(f1, f2):
                line1 = line[0]
                line2 = line[1]

                if line1.split(',')[1] =='topic' or line1.split(',')[1] =='amean':
                    continue

                ndcg1 = line1.split(',')[2].strip()
                err1 = line1.split(',')[3].strip()

                ndcg2 = line2.split(',')[2].strip()
                err2 = line2.split(',')[3].strip()

                w1.write('%s\t%s\n' % (ndcg1, ndcg2))
                w2.write('%s\t%s\n' % (err1, err2))
                                    

                

    os.system('/opt/python27/bin/python bootstrap.py -p 10000 --paired bootstrap_gdeval.tmp.ndcg')
    os.system('/opt/python27/bin/python bootstrap.py -p 10000 --paired bootstrap_gdeval.tmp.err')
                
            
