# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import sys
from collections import defaultdict

# 13 quantiles
def delta_to_quantile(delta):
    if delta < -1:
        return 0
    elif -1 <= delta < -0.8:
        return 1
    elif -0.8 <= delta < -0.6:
        return 2
    elif -0.6 <= delta < -0.4:
        return 3
    elif -0.4 <= delta < -0.2:
        return 4
    elif -0.2 <= delta < 0:
        return 5
    elif delta == 0:
        return 6
    elif 0 < delta < 0.2:
        return 7
    elif 0.2 <= delta < 0.4:
        return 8
    elif 0.4 <= delta < 0.6:
        return 9
    elif 0.6 <= delta < 0.8:
        return 10
    elif 0.8 <= delta <= 1:
        return 11
    elif delta > 1:
        return 12

if __name__ == '__main__':
    if len(sys.argv)!=3:
        print 'Usage: %s <baseline_eval> <model_eval>' % sys.argv[0]
        exit(0)

    d1=dict()

    with open(sys.argv[1], 'r') as f1:
        for line in f1:
            if line.startswith('map'):
                parts = line.split('\t')
                if parts[1].isdigit():
                    qid = int(parts[1])
                    map_value = float(parts[2])
                    d1[qid] = map_value

    d2=dict()
    with open(sys.argv[2], 'r') as f2:
        for line in f2:
            if line.startswith('map'):
                parts = line.split('\t')
                if parts[1].isdigit():
                    qid = int(parts[1])
                    map_value = float(parts[2])
                    d2[qid] = map_value

    quantile_dict = dict()

    for quantile in range(0, 13):
        quantile_dict[quantile] = 0

    for qid in d1:
        delta = None
        if d1[qid] == d2[qid]:
            delta = 0
        elif d1[qid] == 0:
            delta = float('inf')
        else:
            delta = (d2[qid] - d1[qid]) / d1[qid]

        quantile = delta_to_quantile(delta)
        quantile_dict[quantile] += 1

    for quantile in range(0,13):
        print quantile_dict[quantile],





