# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

from xml.dom.minidom import parse
import os
import sys
import subprocess

if len(sys.argv) < 2:  
    print 'Usage: %s <clueweb_query.xml>' % (sys.argv[0])
    sys.exit()

doc = parse(sys.argv[1])

topics = doc.getElementsByTagName('topic')

for topic in topics:
    number = int(topic.getAttribute('number'))
    #print number
    descs = topic.getElementsByTagName('description')
    for desc in descs:
        query = desc.childNodes[0].nodeValue.replace('\n', ' ').strip()
        ofile = open('_tmp.q','w')
        ofile.write('%s\n'%query)
        ofile.close();
        print '=== %d: %s ===' % ( number, query)
        processed_query = subprocess.check_output(('./remove_metaterms.pl _tmp.q').split(' ')).strip()
        ofile = open('_tmp.removed.q','w')
        ofile.write('%s\n'%processed_query)
        ofile.close();
        query_part_file = open('../clueweb09_queries/%d.q.part' % number, 'w')
        query_part_file.write('  <query><type>indri</type><number>%d</number><text>\n    #combine(%s)\n  </text></query>\n' %(number, processed_query))
        query_part_file.close()
        query_file = open('../clueweb09_queries/%d.q' % number, 'w')
        query_file.write('<parameters>\n  <query><type>indri</type><number>%d</number><text>\n    #combine(%s)\n  </text></query>\n</parameters>\n' %(number, processed_query))
        query_file.close()
        #os.system('./depparse.pl _tmp.removed.q > ../clueweb09_parses/%d.dep' % number)

        

