# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import sys

def compute_err_raw(train_file, predict_file):
    tr_file = open(train_file, 'r')
    pr_file = open(predict_file, 'r')

    orig_arr = []
    for line in tr_file:
        parts = line.split(' ')
        true_recall_odd = float(parts[0])
        true_recall = true_recall_odd / ( true_recall_odd + 1)
        orig_arr.append(true_recall)

    tr_file.close()

    pred_arr = []
    for line in pr_file:
        parts = line.split(' ')
        pred_recall_odd = float(parts[0])
        if pred_recall_odd < 0.01:
            pred_recall_odd = 0.01
        
        pred_recall = pred_recall_odd / ( pred_recall_odd + 1)
        pred_arr.append(pred_recall)

    pr_file.close()

    err_sum = 0
    for i in range(0, len(pred_arr)):
        err_sum += abs(orig_arr[i] - pred_arr[i])

    return err_sum / len(orig_arr)
        

def compute_err(train_file, predict_file):
    tr_file = open(train_file, 'r')
    pr_file = open(predict_file, 'r')
    
    orig_arr = []
    orig_norm = []
    pred_arr = []
    pred_norm = []
    
    for line in tr_file:
        parts = line.split(' ')
        qid = int(line.split('\t')[-1])
#        qid = int(parts[len(parts)-1])
        true_recall_odd = float(parts[0])
        true_recall = true_recall_odd / ( true_recall_odd + 1)
        orig_arr.append((qid,true_recall))
        
    tr_file.close()
        
    for line in pr_file:
        parts = line.split(' ')
        pred_recall_odd = float(parts[0])
        if pred_recall_odd < 0.01:
            pred_recall_odd = 0.01

        pred_recall = pred_recall_odd / ( pred_recall_odd + 1)
        pred_arr.append(pred_recall)

    pr_file.close()
    
    previous_qid = orig_arr[0][0]
    norm_constant = 0
    count = 0
    for x in orig_arr:
        qid = x[0]
        if qid==previous_qid:
            norm_constant = norm_constant + x[1]
            count += 1
        else:
            for i in range(0,count):
                orig_norm.append(norm_constant)
        
            norm_constant = x[1]
            count = 1
            previous_qid = qid

    for i in range(0,count):
        orig_norm.append(norm_constant)
        
    previous_qid = orig_arr[0][0]
    norm_constant = 0
    count = 0
    for i in range(0, len(pred_arr)):
        qid = orig_arr[i][0]
        if qid==previous_qid:
            norm_constant += pred_arr[i]
            count += 1
        else:
            for j in range(0, count):
                pred_norm.append(norm_constant)

            norm_constant = pred_arr[i]
            count = 1
            previous_qid = qid

    for j in range(0, count):
        pred_norm.append(norm_constant)

    err_sum = 0
    for i in range(0,len(orig_arr)):
        err_sum += abs(orig_arr[i][1] / orig_norm[i] - pred_arr[i] / pred_norm[i])
    
    return err_sum / len(orig_arr)


    

    




    
    
    

