# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
from query_term_feature_le import *
from time import strftime

def prepare_svm_file(qids, mu, fbdoc, svddim, filename):
    with open(filename, 'w') as svm_out:
        for qid in qids:
            ifilename = '../qtfs/q%d.okw.desc.mu%d.fbdocs%d.svddim%d.svm' %(qid, mu, fbdoc, svddim)
            if not os.path.exists(ifilename):
                continue

            with open(ifilename, 'r') as ifile:
                for line in ifile:
                    svm_out.write('%s\n' % line.strip())


def tid2range(tid):
    if tid==21:
        return range(2001, 2100)
    if tid==22:
        return range(2101, 2201)
    
    if tid==35:
        return range(151, 301)
    if tid==37:
        return range(151, 401)
    if tid==39:
        return range(151, 501)

    if tid==13 or tid==14:
        tid+=1

    return range(tid*50+1, tid*50 + 51)

def tid2range2(tid):
    if tid==7:
        return range(351, 431) + range(441,451)
    if tid==8: 
        return range(431, 441)

def get_test_tid(tid):
    if tid==35:
        return 6
    if tid==37:
        return 8
    if tid==39:
        return 10
    if tid==8:
        return 6
    else:
        return tid+1

def get_test_tid2(tid):
    if tid==35:
        return 6
    if tid==37:
        return 8
    if tid==39:
        return 10
    else:
        return tid

def getTTFbdocs(test_tid):
    if test_tid ==3:
        return [300]
    elif test_tid==7:
        return [150]
    elif test_tid==9:
        return [250]
    elif test_tid==11:
        return [600]
    elif test_tid==35:
        return [300]
    elif test_tid==37:
        return [150]
    elif test_tid==39:
        return [250]


#for trecno in range(3,13,2) + [35, 37,39]:
#for trecno in range(7,13,2):
#for trecno in [13]:
#for trecno in range(7,15,2) + [21]:
#for trecno in range(7,13,2):
for trecno in range(7,15,2):
#for trecno in range(13,15,2):
#for trecno in [21]:
#for trecno in range(3,7,2):
#for trecno in range(7,9,2):
#for trecno in range(4,13,2):
#for trecno in [5,7,9]:
#for trecno in [3]:
    test_tid = get_test_tid(trecno)
    train_qids = tid2range(trecno)
    test_qids = tid2range(test_tid)
    
    mu = 2500
    
    #    for fbdoc in [300]:
    for fbdoc in [100,150,200,250,300,350,400,450,500,550,600]:
    #for fbdoc in [600]:

#    for fbdoc in getFbdocs(test_tid, mu):
#    for fbdoc in getTTFbdocs(trecno):
        for svddim in [150]:#,100,50]:
#            tmp_folder = '../tmp_20140123_all'
#            tmp_folder = '../tmp_20140123_FG2'
#            tmp_folder = '../tmp_20140123_FG3'
#            tmp_folder = '../tmp_20140123_FG4'
#            tmp_folder = '../tmp_20140123_FG5'
#            tmp_folder = '../tmp_20140123_FG6'
            tmp_folder = '../tmp'

            train_svm_filename = '%s/q%d-%d.%d.desc.fbdoc%d.svddim%d.train.svm' % (tmp_folder, train_qids[0], train_qids[-1], len(train_qids), fbdoc, svddim)
            test_svm_filename = '%s/q%d-%d.%d.desc.fbdoc%d.svddim%d.train.svm' % (tmp_folder, test_qids[0], test_qids[-1], len(test_qids), fbdoc, svddim)
            prepare_svm_file(train_qids, mu, fbdoc, svddim, train_svm_filename);
            prepare_svm_file(test_qids, mu, fbdoc, svddim, test_svm_filename);

            os.system('/opt/python27/bin/python2.7 svm2mtb_complete.py %s' % (train_svm_filename))
            os.system('/opt/python27/bin/python2.7 svm2mtb_complete.py %s' % (test_svm_filename))

#            os.system('/opt/python27/bin/python2.7 svm2mtb.py ../tmp/%s' % train_svm_filename)
#            os.system('/opt/python27/bin/python2.7 svm2mtb.py ../tmp/%s' % test_svm_filename)

#            for lamda in ['0.0001','0.001','0.01','0.1','0']:  # for exp prior deep
            for lamda in ['0', '0.0001','0.001','0.01','0.1','1','10','100']: # for deep
#            for lamda in ['0.015625','0.03125', '0.0625','0.125','0.25','0.5','1', '2', '4', '16']:
#            for lamda in ['0']:
#            for lamda in ['0.0009765625', '0.001953125', '0.00390625', '0.0078125', '0.015625','0.03125', '0.0625','0.125','0.25','0.5', '0']:#, '1','2','4']:

#                for gamma in ['1','10','100','1000','10000','100000']:
#                for gamma in ['32', '64', '128', '256', '512', '1024']:


#                for gamma in ['0.5', '1', '2', '4', '8']:#, '16']: # for exp prior deep
                for gamma in ['0']: # for deep
                    jobstr = '%s.%s.%s.%s' %(train_svm_filename.split('/')[-1], lamda,  gamma, strftime('%Y%m%d'))
                    jobname = '.jobs/' + jobstr + '.job'
                    f = open(jobname, 'w')
                    f.write('Universe = vanilla\n')
                    f.write('initialdir = /bos/usr0/gzheng/TermRecall/src\n')
                    f.write('executable = /opt/python27/bin/python\n')

                    f.write('arguments = kernel_cons_condor.py %s %s %s %s %d\n'%( train_svm_filename,  test_svm_filename, lamda, gamma, test_tid))
#                    f.write('arguments = kernel_cons_condor_fg2.py %s %s %s %s %d\n'%( train_svm_filename,  test_svm_filename, lamda, gamma, test_tid))
#                    f.write('arguments = kernel_cons_condor_fg3.py %s %s %s %s %d\n'%( train_svm_filename,  test_svm_filename, lamda, gamma, test_tid))
#                    f.write('arguments = kernel_cons_condor_fg4.py %s %s %s %s %d\n'%( train_svm_filename,  test_svm_filename, lamda, gamma, test_tid))
#                    f.write('arguments = kernel_cons_condor_fg5.py %s %s %s %s %d\n'%( train_svm_filename,  test_svm_filename, lamda, gamma, test_tid))
#                    f.write('arguments = kernel_cons_condor_fg6.py %s %s %s %s %d\n'%( train_svm_filename,  test_svm_filename, lamda, gamma, test_tid))

                    f.write('output = .jobs/'+jobstr+'.out\n')
                    f.write('log = .jobs/'+jobstr+'.log\n')
                    f.write('error = .jobs/'+jobstr+'.err\n')
                    f.write('queue\n')
                    f.close()
                    os.system('condor_submit '+ jobname)
