# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
from query_term_feature_le import *
from time import strftime
import random


def tid2range(tid):
    if tid==35:
        return range(151, 301)
    if tid==37:
        return range(151, 401)
    if tid==39:
        return range(151, 501)

    if tid==13 or tid==14:
        tid+=1

    return range(tid*50+1, tid*50 + 51)

def prepare_svm_file(qids, mu, fbdoc, svddim, filename):
    with open(filename, 'w') as svm_out:
        for qid in qids:
            ifilename = '../qtfs/q%d.okw.desc.mu%d.fbdocs%d.svddim%d.svm' %(qid, mu, fbdoc, svddim)
            if not os.path.exists(ifilename):
                continue

            with open(ifilename, 'r') as ifile:
                for line in ifile:
                    svm_out.write('%s\n' % line.strip())

            

def tid2range2(tid):
    if tid==7:
        return range(351, 431) + range(441,451)
    if tid==8: 
        return range(431, 441)

def get_test_tid(tid):
    if tid==35:
        return 6
    if tid==37:
        return 8
    if tid==39:
        return 10
    if tid==8:
        return 6
    else:
        return tid+1

def get_test_tid2(tid):
    if tid==35:
        return 6
    if tid==37:
        return 8
    if tid==39:
        return 10
    else:
        return tid

def getTTFbdocs(test_tid):
    if test_tid ==3:
        return [300]
    elif test_tid==7:
        return [150]
    elif test_tid==9:
        return [250]
    elif test_tid==11:
        return [600]
    elif test_tid==35:
        return [300]
    elif test_tid==37:
        return [150]
    elif test_tid==39:
        return [250]


#for trecno in range(3,13,2) + [35, 37,39]:
#for trecno in range(3,13,2):
#for trecno in range(3,7,2):
for trecno in range(7,9,2):
#for trecno in range(4,13,2):
#for trecno in [5,7,9]:
#for trecno in [3]:
    test_tid = get_test_tid(trecno)
    train_qids = tid2range(trecno)
    
    all_qids = tid2range(test_tid)
    
    rep = 1
    
    for r in range(1,rep+1):
        # Shuffle the training queries
        #random.shuffle(all_qids)

        k = 5
        for fold in range(1, k+1):
            valid_qids = []
            test_qids = []
            
            N = len(all_qids)
            fold_size = N / k
            
            for j in range(0, N):
                if j >= (fold -1) * fold_size and j < fold * fold_size:
                    test_qids.append(all_qids[j])
                else:
                    valid_qids.append(all_qids[j])
        
            mu = 2500
            
            for fbdoc in [100,200,300,400,500,600]:
#            for fbdoc in [100,150,200,250,300,350,400,450,500,550,600]:
                #    for fbdoc in getFbdocs(test_tid, mu):
                #    for fbdoc in getTTFbdocs(trecno):
                for svddim in [50]:#150,100,50]:
                    train_svm_filename = '../tmp/t%d.desc.fbdoc%d.svddim%d.rep%d.fold%d.train.svm' % (trecno, fbdoc, svddim, r, fold)
                    valid_svm_filename = '../tmp/t%d.desc.fbdoc%d.svddim%d.rep%d.fold%d.valid.svm' % (test_tid, fbdoc, svddim, r, fold)
                    test_svm_filename = '../tmp/t%d.desc.fbdoc%d.svddim%d.rep%d.fold%d.test.svm' % (test_tid, fbdoc, svddim, r, fold)
                    prepare_svm_file(train_qids, mu, fbdoc, svddim, train_svm_filename);
                    prepare_svm_file(valid_qids, mu, fbdoc, svddim, valid_svm_filename);
                    prepare_svm_file(test_qids, mu, fbdoc, svddim, test_svm_filename);
                    
                    os.system('/opt/python27/bin/python2.7 svm2mtb_complete.py %s' % train_svm_filename)
                    os.system('/opt/python27/bin/python2.7 svm2mtb_complete.py %s' % valid_svm_filename)
                    os.system('/opt/python27/bin/python2.7 svm2mtb_complete.py %s' % test_svm_filename)
                    
                    #            os.system('/opt/python27/bin/python2.7 svm2mtb.py ../tmp/%s' % train_svm_filename)
                    #            os.system('/opt/python27/bin/python2.7 svm2mtb.py ../tmp/%s' % test_svm_filename)
                    
                    #            for lamda in [0.0001,0.001,0.01,0.1,1,10,100]:
                    #            for lamda in ['0', '0.0001','0.001','0.01','0.1','1','10','100']:
                    #            for lamda in ['0.015625','0.03125', '0.0625','0.125','0.25','0.5','1', '2', '4', '16']:
                    for lamda in ['0.0009765625', '0.001953125', '0.00390625', '0.0078125', '0.015625','0.03125', '0.0625','0.125','0.25','0.5', '0']:#, '1','2','4']:
                        for gamma in ['0.5', '1', '2', '4', '8']:#, '16']:
                            jobstr = '%s.%s.%s.%s' %(train_svm_filename.split('/')[-1], lamda,  gamma, strftime('%Y%m%d'))
                            jobname = '.jobs/' + jobstr + '.job'
                            f = open(jobname, 'w')
                            f.write('Universe = vanilla\n')
                            f.write('initialdir = /bos/usr2/gzheng/TermRecall/src\n')
                            f.write('executable = /opt/python27/bin/python\n')
                            f.write('arguments = kernel_cons_condor.py %s %s %s %s %d\n'%(train_svm_filename, valid_svm_filename, lamda, gamma, test_tid))
                            f.write('output = .jobs/'+jobstr+'.out\n')
                            f.write('log = .jobs/'+jobstr+'.log\n')
                            f.write('error = .jobs/'+jobstr+'.err\n')
                            f.write('queue\n')
                            f.close()
                            os.system('condor_submit '+ jobname)    
                            
