# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
from query_term_feature_le import *
from condor_cv_svm import prepare_svm_file
from time import strftime

def tid2range(tid):
    if tid==35:
        return range(151, 301)
    if tid==37:
        return range(151, 401)
    if tid==39:
        return range(151, 501)

    if tid==13 or tid==14:
        tid+=1

    return range(tid*50+1, tid*50 + 51)

def get_test_tid(tid):
    if tid==35:
        return 6
    if tid==37:
        return 8
    if tid==39:
        return 10
    else:
        return tid+1


for trecno in range(3,13,2) + [35, 37,39]:
#for trecno in [3]:
    test_tid = get_test_tid(trecno)
    train_qids = tid2range(trecno)
    test_qids = tid2range(test_tid)
    
    mu = 900
    if test_tid ==9 or test_tid == 10:
        mu = 1500

    for fbdoc in getFbdocs(test_tid, mu):
        for svddim in [150]:
            prepare_svm_file(train_qids, fbdoc, svddim, '', 'train')
            prepare_svm_file(test_qids, fbdoc, svddim, '', 'train')
            train_svm_filename = 'q%d-%d.%d.desc.fbdoc%d.svddim%d.train.svm' % (train_qids[0], train_qids[-1], len(train_qids), fbdoc, svddim)
            test_svm_filename = 'q%d-%d.%d.desc.fbdoc%d.svddim%d.train.svm' % (test_qids[0], test_qids[-1], len(test_qids), fbdoc, svddim)
            os.system('/opt/python27/bin/python2.7 svm2mtb.py ../tmp/%s' % train_svm_filename)
            os.system('/opt/python27/bin/python2.7 svm2mtb.py ../tmp/%s' % test_svm_filename)

#            for lamda in [0.0001,0.001,0.01,0.1,1,10,100]:
            for lamda in ['0.0001','0.001','0.01','0.1','1','10','100']:
                jobstr = '%s.%s.%s' %(train_svm_filename, lamda,  strftime('%Y%m%d'))
                jobname = '.jobs/' + jobstr + '.job'
                f = open(jobname, 'w')
                f.write('Universe = vanilla\n')
                f.write('initialdir = /bos/usr2/gzheng/TermRecall/src\n')
                f.write('executable = /opt/python27/bin/python\n')
                f.write('arguments = ./linear_cons_condor.py ../tmp/%s ../tmp/%s %s %d\n'%(train_svm_filename, test_svm_filename, lamda, test_tid))
                f.write('output = .jobs/'+jobstr+'.out\n')
                f.write('log = .jobs/'+jobstr+'.log\n')
                f.write('error = .jobs/'+jobstr+'.err\n')
                f.write('queue\n')
                f.close()
                os.system('condor_submit '+ jobname)    
