# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import sys
import os
import subprocess


if len(sys.argv)!=3:
    print 'Usage: %s <input.part> <output.svm>' % sys.argv[0]
    exit(0)


max_svd1 = sys.float_info.min
max_svd2 = sys.float_info.min
max_svd3 = sys.float_info.min

with open(sys.argv[1], 'r') as feat_in:
    for line in feat_in:
        parts = line.strip().split(' ')
        svd1 = float(parts[2].split(':')[-1])
        svd2 = float(parts[3].split(':')[-1])
        svd3 = float(parts[4].split(':')[-1])

        if svd1 > max_svd1:
            max_svd1 = svd1

        if svd2 > max_svd2:
            max_svd2 = svd2

        if svd3 > max_svd3:
            max_svd3 = svd3


print max_svd1, max_svd2, max_svd3

with open(sys.argv[1], 'r') as feat_in, open(sys.argv[2], 'w') as feat_out:
    for line in feat_in:
        parts = line.strip().split(' ')
        svd1 = float(parts[2].split(':')[-1])
        svd2 = float(parts[3].split(':')[-1])
        svd3 = float(parts[4].split(':')[-1])

        segs = line.strip().split('#', 1)
        feat_out.write('%s 901:%f 902:%f 903:%f #%s\n' % (segs[0].strip(), svd1/max_svd1, svd2/max_svd2, svd3/max_svd3, segs[1].strip()))
        
        
        



