# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import sys

if len(sys.argv)!=3:
    print 'Usage: %s <dataset_no> <query_output> ' % sys.argv[0]
    exit(0)

qids = []
dataset = int(sys.argv[1])

if dataset == 1:
    qids = range(301, 451) + range(601, 701)
elif dataset == 2:
    qids = range(451, 501)
elif dataset == 3:
    qids = range(701, 751) + range(801, 851)
elif dataset == 4:
    qids = range(2001, 2101)

if len(qids)==0:
    exit(0)

with open(sys.argv[2], 'w') as q_out:
    q_out.write('<parameters>\n')
    
    for qid in qids:
        q_out.write('\t<query><type>indri</type><number>%d</number><text>\n#combine(\n' % qid)

        with open('../queries/desc_parts_stopped/%s.part' % qid, 'r') as part_in:
            for line in part_in:
                if line.startswith('#'):
                    continue
                q_out.write('\t%s\n' % line.strip())

        q_out.write(' )\n')
        q_out.write('\t</text></query>\n')

    q_out.write('</parameters>\n')
    
