# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
import sys
import glob


for target in [4,6,8,10,12]:
    for filename in glob.glob('../svm/t%s*' % target):
        fsuffix = filename.split('/')[-1]
        startqid = target * 50 + 1
        endqid = target * 50 + 50
        svm1name = '%s.2-1' % fsuffix
        svm2name = '%s.2-2' % fsuffix
        w1 = open('../svm_target/%s' % svm1name, 'w')
        w2 = open('../svm_target/%s' % svm2name, 'w')
        reader = open(filename, 'r')

        for line in reader:
            line = line.strip()
            qid = int(line.split(' ')[-1])
            w = w2
            if qid < startqid + 25:
                w = w1

            splits = line.split(' ',1)
            oddp = float(splits[0])
            p = oddp / (oddp + 1.0)
            w.write('%f %s\n'%(p, splits[1]))
        
        w1.close()
        w2.close()
        reader.close()

        os.system("../libsvm-3.14/svm-scale -l -u -s ../svm_rescale/%s.param ../svm_target/%s > ../svm_rescale/%s.rescale" % (svm1name, svm1name, svm1name))
        os.system("../libsvm-3.14/svm-scale -r ../svm_rescale/%s.param ../svm_target/%s > ../svm_rescale/%s.rescale" % (svm2name, svm2name, svm2name))

        jobstr = svm1name
        jobname = ".jobs/" + svm1name + ".job"
        f = open(jobname, "w")
        f.write("Universe = vanilla\n")
        f.write("initialdir = /bos/usr2/gzheng/TermRecall/src\n")
        f.write("executable = /opt/python27/bin/python\n")
        f.write("arguments = ../libsvm-3.14/tools/gridregression.py -out ../out/%s ../svm_rescale/%s.rescale\n " % (svmfilename, svmfilename))
        f.write("output = .jobs/"+jobstr+".out\n")
        f.write("log = .jobs/"+jobstr+".log\n")
        f.write("error = .jobs/"+jobstr+".err\n")
        f.write("queue\n")
        f.close()
        os.system("condor_submit "+ jobname)

        jobstr = svm2name
        jobname = ".jobs/" + svm2name + ".job"
        f = open(jobname, "w")
        f.write("Universe = vanilla\n")
        f.write("initialdir = /bos/usr2/gzheng/TermRecall/src\n")
        f.write("executable = /opt/python27/bin/python\n")
        f.write("arguments = ../libsvm-3.14/tools/gridregression.py -out ../out/%s ../svm_rescale/%s.rescale\n " % (svmfilename, svmfilename))
        f.write("output = .jobs/"+jobstr+".out\n")
        f.write("log = .jobs/"+jobstr+".log\n")
        f.write("error = .jobs/"+jobstr+".err\n")
        f.write("queue\n")
        f.close()
        os.system("condor_submit "+ jobname)





