# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import sys
import os
import glob
from time import strftime

for filename in  glob.glob('/bos/usr0/gzheng/TermRecall/queries/desc_parts_stopped/*.part'):
    jobstr = 'partsvm.q%s.%s' %(filename.split('/')[-1], strftime('%Y%m%d'))
    jobname = '.jobs/' + jobstr + '.job'

    print jobname
    with open(jobname, 'w') as f:
        f.write('Universe = vanilla\n')
        f.write('getenv = True\n')
        f.write('initialdir = /bos/usr0/gzheng/TermRecall/src\n')
        f.write('executable = /opt/python27/bin/python\n')
        f.write('arguments = get_external_feature.py %s %s.svm\n'%( filename, filename))
        f.write('output = .jobs/'+jobstr+'.out\n')
        f.write('log = .jobs/'+jobstr+'.log\n')
        f.write('error = .jobs/'+jobstr+'.err\n')
        f.write('queue\n')
        f.close()
    os.system('condor_submit '+ jobname)



