# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
import sys
import subprocess
from Constants import *

if len(sys.argv)!=6:
    print 'Usage: %s <train_svm> <test_svm> <lambda> <gamma> <test_tid>'
    exit(0)

train_file = sys.argv[1]
test_file = sys.argv[2]
lamda = sys.argv[3]
gamma = sys.argv[4]
trecid = int(sys.argv[5])

#command = '/opt/matlab/7.13/bin/matlab -nodesktop -nojvm -singleCompThread -nosplash -r \"doit_kernel(\'%s.A\', \'%s.B\', \'%s.y\', \'%s.A\', \'%s.B\', \'%s\')\"' %(train_file, train_file, train_file, test_file, test_file, lamda)

#direct regression
#command = '/opt/matlab/7.13/bin/matlab -nodesktop -nojvm -singleCompThread -nosplash -r \"doit_kernel_SIGIR_p2(\'%s.A\', \'%s.B\', \'%s.y\', \'%s.A\', \'%s.B\', \'%s\', \'%s\')\"' %(train_file, train_file, train_file, test_file, test_file, lamda, gamma)

#direct regression with deep features
command = '/opt/matlab/7.13/bin/matlab -nodesktop -nojvm -singleCompThread -nosplash -r \"doit_kernel_SIGIR_deep(\'%s.A\', \'%s.B\', \'%s.y\', \'%s.A\', \'%s.B\', \'%s\', \'%s\')\"' %(train_file, train_file, train_file, test_file, test_file, lamda, gamma)

#relative regression
#command = '/opt/matlab/7.13/bin/matlab -nodesktop -nojvm -singleCompThread -nosplash -r \"doit_kernel_SIGIR_rel(\'%s.A\', \'%s.starts\', \'%s.ends\', \'%s.B\', \'%s.y\', \'%s.A\', \'%s.B\', \'%s\', \'%s\')\"' %(train_file, train_file, train_file, train_file, train_file, test_file, test_file, lamda, gamma)

#relative regression exp
#command = '/opt/matlab/7.13/bin/matlab -nodesktop -nojvm -singleCompThread -nosplash -r \"doit_kernel_SIGIR_rel_exp(\'%s.A\', \'%s.starts\', \'%s.ends\', \'%s.B\', \'%s.y\', \'%s.A\', \'%s.B\', \'%s\', \'%s\')\"' %(train_file, train_file, train_file, train_file, train_file, test_file, test_file, lamda, gamma)
os.system(command)

# weighted keyword query
#os.system('/opt/python27/bin/python2.7 wqg_P_SIGIR.py %s %s.A.%s.A.L%s.g%s.out ../queries/desc_parts_stopped %s.%s.L%s.g%s.q' %(test_file, train_file, test_file.split('/')[-1], lamda, gamma, train_file, test_file.split('/')[-1], lamda, gamma))

# deep weighted sd - (unigrams weighted only)
os.system('/opt/python27/bin/python2.7 wqg_P_mixed_deep.py %s %s.A.%s.A.L%s.g%s.out ../queries/desc_parts_stopped %s.%s.L%s.g%s.q' %(test_file, train_file, test_file.split('/')[-1], lamda, gamma, train_file, test_file.split('/')[-1], lamda, gamma))

# flat sd stype SIGIR
#os.system('/opt/python27/bin/python2.7 wqg_P_sdm_SIGIR.py %s %s.A.%s.A.L%s.g%s.out ../queries/desc_parts_stopped %s.%s.L%s.g%s.q' %(test_file, train_file, test_file.split('/')[-1], lamda, gamma, train_file, test_file.split('/')[-1], lamda, gamma))

# flat sd style
#os.system('./wqg_P %s %s.A.%s.A.L%s.out %s.%s.L%s.q' %(test_file, train_file, test_file.split('/')[-1], lamda, train_file, test_file.split('/')[-1], lamda))

#mixed sd style
#############################################
#### THIS ONE IS USED BEFORE DEEP FEATURES###
############################################
#os.system('/opt/python27/bin/python2.7 wqg_P_mixed_SIGIR.py %s %s.A.%s.A.L%s.g%s.out %s.%s.L%s.g%s.q 0.8 0.1 0.1' %(test_file, train_file, test_file.split('/')[-1], lamda, gamma, train_file, test_file.split('/')[-1], lamda, gamma))

#original sd style
#os.system('/opt/python27/bin/python2.7 wqg_recall_sdm.py %s %s.A.%s.A.L%s.g%s.out %s.%s.L%s.g%s.q 0.8 0.1 0.1' %(test_file, train_file, test_file.split('/')[-1], lamda, gamma, train_file, test_file.split('/')[-1], lamda, gamma))

#indri 4.10
#os.system('/bos/usr2/gzheng/Boolean/app-4.10/IndriRunQuery -count=1000 %s.%s.L%s.q -index=/bos/tmp17/gzheng/trec/indext%d-v4.10/ -trecFormat=t -rule=method:d,mu:%d > ../res/%s.%s.L%s.res' %(train_file, test_file.split('/')[-1], lamda, trecid, mus[trecid], train_file.split('/')[-1], test_file.split('/')[-1], lamda))


#indri 5.3 for weighted sd query
os.system('/bos/usr0/gzheng/.local/bin/IndriRunQuery -count=1000 %s.%s.L%s.g%s.q -index=/bos/tmp17/gzheng/trec/indext%d-v5.3/ -trecFormat=t -rule=method:d,mu:2500 > ../res/%s.%s.L%s.g%s.res' %(train_file, test_file.split('/')[-1], lamda, gamma, trecid, train_file.split('/')[-1], test_file.split('/')[-1], lamda, gamma))

eval_output_test = subprocess.check_output(('./trec_eval ../qrels/qrels.t%d.txt ../res/%s.%s.L%s.g%s.res' %(trecid, train_file.split('/')[-1], test_file.split('/')[-1], lamda, gamma)).split(' '))
eval_map_test = float(eval_output_test.strip().split('\n')[5].split('\t')[-1])

print 'ALL_CONS_RESULT: %s\t%s\t%s\t%s\t%f'%(train_file, test_file, lamda, gamma, eval_map_test)
