# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
import sys
import subprocess
from Constants import *

if len(sys.argv)!=5:
    print 'Usage: %s <train_svm> <test_svm> <lambda> <test_tid>'
    exit(0)

train_file = sys.argv[1]
test_file = sys.argv[2]
lamda = sys.argv[3]
trecid = int(sys.argv[4])

command = '/opt/matlab/7.13/bin/matlab -nodesktop -nojvm -singleCompThread -nosplash -r \"doit_linear(\'%s.A\', \'%s.B\', \'%s.y\', \'%s.A\', \'%s.B\', \'%s\')\"' %(train_file, train_file, train_file, test_file, test_file, lamda)
os.system(command)

# flat sd style
#os.system('./wqg_P %s %s.A.L%s.out %s.L%s.q' %(test_file, test_file, lamda, test_file, lamda))

#original sd style
os.system('/opt/python27/bin/python2.7 wqg_recall_sdm.py %s %s.A.%s.A.L%s.out %s.%s.L%s.q 0.8 0.1 0.1' %(test_file, train_file, test_file.split('/')[-1], lamda, train_file, test_file.split('/')[-1], lamda))

os.system('/bos/usr2/gzheng/Boolean/app-4.10/IndriRunQuery -count=1000 %s.%s.L%s.q -index=/bos/tmp17/gzheng/trec/indext%d-v4.10/ -trecFormat=t -rule=method:d,mu:%d > ../res/%s.%s.L%s.res' %(train_file, test_file.split('/')[-1], lamda, trecid, mus[trecid], train_file.split('/')[-1], test_file.split('/')[-1], lamda))

eval_output_test = subprocess.check_output(('./trec_eval ../qrels/qrels.t%d.txt ../res/%s.%s.L%s.res' %(trecid, train_file.split('/')[-1], test_file.split('/')[-1], lamda)).split(' '))
eval_map_test = float(eval_output_test.strip().split('\n')[5].split('\t')[-1])

print 'QUADRATIC_CONS_RESULT: %s\t%s\t%s\t%f'%(train_file, test_file, lamda, eval_map_test)
