# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import sys

if len(sys.argv)!=3:
    print 'Usage: %s <t21|t22> <output_file>'% sys.argv[0]
    exit(0)

infiles = None
if sys.argv[1] == 't21':
    infiles=['../clueweb09_qrels/qrels.2009.adhoc', '../clueweb09_qrels/qrels.2010.adhoc']
else:
    infiles=['../clueweb09_qrels/qrels.2011.adhoc', '../clueweb09_qrels/qrels.2012.adhoc']
 

outfile = open(sys.argv[2], 'w')
for infile_name in infiles:
    with open(infile_name, 'r') as inf:
        for line in inf:
            parts = line.strip().split(' ', 1)
            qid = int(parts[0])
            new_qid = qid + 2000
            outfile.write('%d %s\n' % (new_qid, parts[1]))


outfile.close()

