# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
import sys
import glob

def merge(infile1, infile2, outfile):
    r1=open(infile1,'r')
    r2=open(infile2,'r')
    lines1 = r1.readlines()
    lines2 = r2.readlines()
    if len(lines1)!=len(lines2):
        r1.close()
        r2.close()
        return False

    w=open(outfile,'w')
    for i in range(0, len(lines1)):
        line1 = lines1[i]
        line2 = lines2[i]
        parts1 = line1.strip().split('#')
        parts2 = line2.strip().split('#')
        feats1 = parts1[0].strip().split(' ')
        feat_index = int(feats1[-1].split(':')[0])
        w.write('%s'%parts1[0])
        if parts1[1]==parts2[1]:
            feats2 = parts2[0].strip().split(' ')
            for k in [2,3,4]:
                feat_index +=1
                w.write('%d:%s '%(feat_index, feats2[k].split(':')[1]))
        w.write('#%s\n'%parts1[1])
    w.close()
    r1.close()
    r2.close()
    return True

for filename in glob.glob('../qtfs/*.bsample.1*'):
    print filename
    prefix = filename.split('.bsample')[0]
    for i in range(1,6):
        if i==1:
            outputf = '%s.nsample.%d.svm'%(prefix,i)
            w=open(outputf, 'w')
            inputf = '%s.bsample.1.svm'%(prefix)
            r=open(inputf, 'r')
            for line in r:
                w.write('%s\n'%(line.strip()))
            w.close()
            r.close()
        else:
            inf1 = '%s.nsample.%d.svm'%(prefix,i-1)
            inf2 = '%s.bsample.%d.svm'%(prefix,i)
            outf = '%s.nsample.%d.svm'%(prefix,i)

            # merge failed
            if not merge(inf1, inf2, outf):
                break
                
