# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
import sys
import glob

def merge(infile1, infile2, outfile):
    if not os.path.exists(infile1) or not os.path.exists(infile2):
        return False

    r1=open(infile1,'r')
    r2=open(infile2,'r')
    lines1 = r1.readlines()
    lines2 = r2.readlines()
    if len(lines1)!=len(lines2):
        r1.close()
        r2.close()
        return False

    w=open(outfile,'w')
    for i in range(0, len(lines1)):
        line1 = lines1[i]
        line2 = lines2[i]
        parts1 = line1.strip().split('#')
        parts2 = line2.strip().split('#')
        feats1 = parts1[0].strip().split(' ')
        feat_index = int(feats1[-1].split(':')[0])
        w.write('%s'%parts1[0])
        if parts1[1]==parts2[1]:
            feats2 = parts2[0].strip().split(' ')
            for k in [2,3,4]:
                feat_index +=1
                w.write('%d:%s '%(feat_index, feats2[k].split(':')[1]))
        w.write('#%s\n'%parts1[1])
    w.close()
    r1.close()
    r2.close()
    return True

for filename in glob.glob('../smallsets_qtfs_plsa/*'):
    suffix = filename.split('/')[-1]
    svd_filename = '../smallsets_qtfs_svd/%s'%suffix
    out_filename = '../smallsets_qtfs_svd_plsa/%s'%suffix
    print 'MERGING %s %s INTO %s.' %(svd_filename, filename, out_filename)
    merge(svd_filename, filename, out_filename)
