# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import glob
import sys

if len(sys.argv)!=3:
    print 'Usage: %s <qtfs_input_dir> <qtfs_output_dir> '% sys.argv[0]
    exit(0)

def oddp2p(a):
    return a/(a+1.0)

def subtract(a,b):
    a_parts = a.split(' ')
    b_parts = b.split(' ')
    
    oddpa = float(a_parts[0])
    oddpb = float(b_parts[0])

    p = oddp2p(oddpa) - oddp2p(oddpb)
    oddp = p / (1.0 - p)

    f1a = float(a_parts[1].split(':')[-1])
    f1b = float(b_parts[1].split(':')[-1])

    f2a = float(a_parts[2].split(':')[-1])
    f2b = float(b_parts[2].split(':')[-1])

    f3a = float(a_parts[3].split(':')[-1])
    f3b = float(b_parts[3].split(':')[-1])

    f4a = float(a_parts[4].split(':')[-1])
    f4b = float(b_parts[4].split(':')[-1])


    return '%f 1:%f 2:%f 3:%f 4:%f 69:0' % ( p, f1a-f1b, f2a-f2b, f3a-f3b, f4a-f4b)
    

for filename in glob.glob('%s/*' %sys.argv[1]):
    list_term =[]
    list_bigram = []
    list_uw = []
    w = open('%s/%s' % (sys.argv[2], filename.split('/')[-1]), 'w')
    with open(filename, 'r') as f:
        for line in f:
            print line.strip()
            parts = line.split('#', 1)

            # bi-gram
            if parts[1].startswith('#1'):
                list_bigram.append(line.strip())
            # unordered window
            elif parts[1].startswith('#uw8'):
                list_uw.append(line.strip())
            # term
            else:
                list_term.append(line.strip())

    for term_qtf in list_term:
        term = term_qtf.split('#',1)[-1].split('\t')[1]
        match = False
        for uw_qtf in list_uw:
            uw = uw_qtf.split('#',1)[-1].split('\t')[1]
            if term in uw:
                match = True
                w.write('%s #%s\n' % (subtract(term_qtf, uw_qtf), term_qtf.split('#', 1)[-1]))
                break

        if not match:
            w.write('%s\n' % term_qtf)


    for bigram_qtf in list_bigram:
        w.write('%s\n'% bigram_qtf)

    for uw_qtf in list_uw:
        match = False
        uw = uw_qtf.split('#', 1)[-1].split('\t')[1]
        for bigram_qtf in list_bigram:
            bigram = bigram_qtf.split('#', 1)[-1].split('\t')[1]
            if uw.split('(',1)[-1].split(')', 1)[0] == bigram.split('(',1)[-1].split(')', 1)[0]:
                match = True
                w.write('%s #%s\n' % (subtract(uw_qtf, bigram_qtf), uw_qtf.split('#', 1)[-1]))
                break

        if not match:
            w.write('%s\n'% uw_qtf)


    w.close()
            
