# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
import glob
import sys

def trecid2qids(trecid):
    if trecid>=13:
        trecid+=1
    
    return range(trecid*50+1,trecid*50+51)

mus=[0, 0, 0, 2200, 2200, 4300, 4300, 6600, 6600, 7200, 7200, 9500, 9500, 9900, 9900]

#for trecno in range(3,15):
for trecno in range(9,15):
    for qid in trecid2qids(trecno):
        for fbdocs in range(500,501,100):
            for svddim in range(100,301,25):
                filename = '../qtfs/q%d.okw.desc.fbdocs%d.svddim%d.rf.svm'%(qid,fbdocs,svddim)
                if not os.path.exists(filename):
                    print filename
                    jobstr =  'q%d.okw.desc.fbdocs%d.svddim%d.rf.svm'%(qid,fbdocs,svddim)
                    jobname = ".jobs/"+jobstr+".job"
                    mu = mus[trecno]
                    f = open(jobname, "w")
                    f.write("Universe = vanilla\n")
                    f.write("initialdir = /bos/usr2/gzheng/TermRecall/src\n")
                    f.write("executable = query_term_feature_gen_rf\n")
                    f.write("arguments = " + str(qid) + " ../res/t" + str(trecno)+".okw.mu"+str(mu)+".res " + str(fbdocs) + " " + str(svddim) + " "+filename+"\n")
                    f.write("output = .jobs/"+jobstr+".out\n")
                    f.write("log = .jobs/"+jobstr+".log\n")
                    f.write("error = .jobs/"+jobstr+".err\n")
                    f.write("queue\n")
                    f.close()
                    os.system("condor_submit "+ jobname)
                    
