# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

from compute_prediction_error import *
import sys
import os
import subprocess
import glob

if len(sys.argv)!=6:
    print 'Usage: %s <train> <test> <qrel> <mu> <gamma>' % sys.argv[0]
    exit(1)

train_file = sys.argv[1]
test_file = sys.argv[2]
qrel_file = sys.argv[3]
mu = int(sys.argv[4])
gamma_arg = float(sys.argv[5])
# CONDOR PART STARTS

# svmlight
for gamma in [gamma_arg]:
    # RBF kernel
#    os.system('./svm_learn -v 0 -z r -t 2 -g %f %s %s.model' % (gamma, train_file, train_file))
    os.system('./svm_learn -v 0 -z r -c 10 -t 2 -g %f %s %s.model' % (gamma, train_file, train_file))

    # linear kernel
    #os.system('./svm_learn -v 0 -z r -t 0 %s.rescale %s.model' % (train_file, train_file))

    # test on dev used to do CV
    # we can also do test on testing so that we do not to do again after we have chosen the right params
    #os.system('./svm_classify -v 0 %s.rescale %s.model %s.out' % ( dev_file, train_file, dev_file))
    os.system('./svm_classify -v 0 %s %s.model %s.out' % ( test_file, train_file, test_file))
    
    #generate weighted query
    #oddp_tag = '_oddp' if '.oddp' in run_tag else ''
    #prob_tag = ' -b 1 ' if '.oddp' not in run_tag else ' '

    os.system('./wqg_oddP %s %s.out %s.q'% (test_file, test_file, test_file))
    #os.system('./wqg_oddP %s %s.out %s.q'% (dev_file, dev_file, dev_file))
        
    #NOTE HERE:
    #Test qids should be in the same trec dataset!!!
    
    #search the query!
    #os.system('/bos/usr2/gzheng/Boolean/app-4.10/IndriRunQuery -count=1000 %s.q -index=/bos/tmp17/gzheng/trec/indext%d-v4.10/ -trecFormat=t -rule=method:d,mu:%d > ../res/%s.res' %(dev_file, trecid, mus[trecid], dev_file.split('/')[-1]))
    
    #category a
    #os.system('/bos/usr2/gzheng/.local/bin/IndriRunQuery -count=1000 %s.q  clueweb_index.param -trecFormat=t -rule=method:d,mu:%d > ../clueweb09_res/%s.res' %(test_file,  mu, test_file.split('/')[-1]))
    #category b spamfiltered version
    os.system('/bos/usr2/gzheng/.local/bin/IndriRunQuery -count=1000 %s.q  clueweb_index_catB_spamfiltered.param -trecFormat=t -rule=method:d,mu:%d > ../clueweb09_res/catB_sf/%s.res' %(test_file,  mu, test_file.split('/')[-1]))
    
#evaluate the results!
    #eval_output_dev = subprocess.check_output(('./trec_eval ../qrels/qrels.t%d.txt ../res/%s.res' %(trecid, dev_file.split('/')[-1])).split(' '))
    eval_output_test = subprocess.check_output(('./trec_eval %s ../clueweb09_res/catB_sf/%s.res' %(qrel_file, test_file.split('/')[-1])).split(' '))
    
    #eval_map_dev = float(eval_output_dev.strip().split('\n')[5].split('\t')[-1])
    eval_map_test = float(eval_output_test.strip().split('\n')[5].split('\t')[-1])

    #weighted_prediction_error_dev  = compute_err(dev_file,  '%s.out'%dev_file)
    weighted_prediction_error_test = compute_err(test_file, '%s.out'%test_file)

    #prediction_error_dev = compute_err_raw(dev_file, '%s.out' % dev_file)
    prediction_error_test= compute_err_raw(test_file, '%s.out'% test_file)
    
    #print '%s\t%s\t%s\t%f\t%f\t%f\t%f\t%f\t%f\t%f' % (train_file, dev_file, test_file, eval_map_dev, eval_map_test, gamma, weighted_prediction_error_dev, weighted_prediction_error_test, prediction_error_dev, prediction_error_test)
    print '%s\t%s\t%f\t%f\t%f\t%f' % (train_file, test_file, eval_map_test, gamma, weighted_prediction_error_test, prediction_error_test)
    
# CONDOR PART ENDS
