# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

from xml.dom.minidom import *
import sys


def bi_query(terms, wt, wo, wu):
    sd_out = '#combine( '

    for i in range(0, len(terms) -1):
        sd_out += '#1( %s %s ) ' % (terms[i], terms[i+1])

    sd_out += ')'
    
    return sd_out

def uw_query(terms, wt, wo, wu):
    sd_out = '#combine( '

    for i in range(0, len(terms) -1):
        sd_out += '#uw8( %s %s ) ' % (terms[i], terms[i+1])

    sd_out += ')'
    
    return sd_out


def sd_query(terms, wt, wo, wu):
    sd_out = '#weight( %f #combine( ' % wt

    for term in terms:
        sd_out += '%s ' % term
    sd_out += ')\n'

    sd_out +='         %f #combine( ' % wo
    for i in range(0, len(terms) -1):
        sd_out += '#1( %s %s ) ' % (terms[i], terms[i+1])

    sd_out += ')\n'
    
    sd_out +='         %f #combine( ' % wu
    for i in range(0, len(terms) -1):
        sd_out += '#uw8( %s %s ) ' % (terms[i], terms[i+1])
        
    sd_out += ') )'
    
    return sd_out

def str_to_parts(query, use_stop_list = False):
    parts = query.strip().split(' ')
    terms = []

    sw = []
    if(use_stop_list):
        sw_f = parse('/bos/usr0/lezhao/Boolean/stoplist.param')
#        sw_f = parse('/bos/tmp4/lezhao/gov2/queries/stoplist.param')
        stopwords = sw_f.getElementsByTagName('word')
        
        for word in stopwords:
            sw.append(word.firstChild.nodeValue.strip().lower())
    
    for part in parts:
        if part != '' and part.strip().lower() not in sw:
            terms.append(part)

    return terms


if __name__ == '__main__':
    if len(sys.argv)!=3:
        print 'Usage: %s <keyword query file> <sd query output>' % sys.argv[0]
        exit(1)

    ifile = open(sys.argv[1], 'r')
    ofile = open(sys.argv[2], 'w')

    # sd weights
    wt = 0.8
    wo = 0.1
    wu = 0.1
    
    for line in ifile: # line should not contain any puntuations
        parts = line.strip().split(' ')
        terms = []
        for part in parts:
            if '/' in part:
                terms.append(part.split('/')[0])

        sd_out = sd_query(terms, wt, wo ,wu)
        print sd_out
        ofile.write('%s\n' % sd_out)

    ofile.close()
    ifile.close()

    
    
