# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

from xml.dom.minidom import *
from sd_query import sd_query, str_to_parts
import string
import sys
import re

if len(sys.argv)!=4:
    print 'Usage: %s <keyword query_xml file> <sd query_xml output> <query partfile dir>' % sys.argv[0]
    exit(1)

ifile = open(sys.argv[1], 'r')
ofile = open(sys.argv[2], 'w')

# sd weights
wt = 0.8
wo = 0.1
wu = 0.1

dom = parse(sys.argv[1])

ofile = open(sys.argv[2], 'w')
ofile.write('<parameters>\n')

queries = dom.getElementsByTagName('query')

for query in queries:
    query_num = int(query.getElementsByTagName('number')[0].firstChild.nodeValue)
    query_txt = query.getElementsByTagName('text')[0].firstChild.nodeValue.strip()
    m = re.search(r'^\#combine\((.*)\)$', query_txt)
    query_txt_raw = m.group(1).strip()

    
    # switch for using stop words ------->
    terms = str_to_parts(query_txt_raw, True)


    print query_num, query_txt_raw

    sd_q =  sd_query(terms, wt, wo, wu)
    
    # +2000 is for clueweb queries
    ofile.write('  <query><type>indri</type><number>%d</number><text>\n' % (query_num))
    ofile.write('%s\n' % sd_q)
    ofile.write('  </text></query>\n')

    query_part_file = open('%s/%d.part' % (sys.argv[3], (query_num)), 'w')

    for term in terms:
        query_part_file.write('%s\n' % term)
        
    for i in range(0, len(terms) - 1):
        query_part_file.write('#1(%s %s)\n' % (terms[i], terms[i+1]))

    for i in range(0, len(terms) - 1):
        query_part_file.write('#uw8(%s %s)\n' % (terms[i], terms[i+1]))
        
    query_part_file.close()

ofile.write('</parameters>\n')
