# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

from Constants import *
import os
import glob
import sys

def getRunStr(rid):
    if rid==1:
        return "wsj87-91"
    elif rid==2:
        return "wsj92"
    elif rid==3:
        return "ap88-89"
    elif rid==4:
        return "ap90"
    elif rid==5:
        return "ziff89-90"
    elif rid==6:
        return "ziff91-92"

def getQids(rid):
    if rid==1:
        return wsj_train_qids
    elif rid==2:
        return wsj_test_qids
    elif rid==3:
        return ap_train_qids
    elif rid==4:
        return ap_test_qids
    elif rid==5:
        return ziff_train_qids
    elif rid==6:
        return ziff_test_qids

for rid in range(1,7):
    for qid in getQids(rid):
        for fbdoc in smallsets_fbdocs:
#            for svddim in smallsets_svddims:
            for svddim in range(100,201,50):
                mu = smallsets_mus[rid]
                filename = '../smallsets_qtfs_plsa/%s.q%d.okw.desc.mu%d.fbdocs%d.svddim%d.svm'%(getRunStr(rid), qid, mu, fbdoc, svddim)
                if not os.path.exists(filename):
                    print filename
                    jobstr =  '%s.q%d.okw.desc.mu%d.fbdocs%d.svddim%d.svm'%(getRunStr(rid),qid,mu,fbdoc,svddim)
                    jobname = ".jobs/"+jobstr+".job"
                    f = open(jobname, "w")
                    f.write("Universe = vanilla\n")
                    f.write("initialdir = /bos/usr2/gzheng/TermRecall/src\n")
                    f.write("executable = smallsets_qtf_gen\n")
                    f.write("arguments = " + str(qid) + " ../smallsets_res/" + getRunStr(rid) + ".okw.mu" + str(mu)+".res /bos/tmp17/gzheng/indexes/" + getRunStr(rid)+" ../smallsets_qrels/" + getRunStr(rid) + ".adhoc ../smallsets_parses/" + str(qid) + ".dep " + str(fbdoc) + " "  + str(svddim) + " "+filename+"\n")
                    f.write("output = .jobs/"+jobstr+".out\n")
                    f.write("log = .jobs/"+jobstr+".log\n")
                    f.write("error = .jobs/"+jobstr+".err\n")
                    f.write("queue\n")
                    f.close()
                    os.system("condor_submit "+ jobname)                
                    
