# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
import glob
import sys
from time import strftime

def getQids(runid):
    if runid == 'st10':
        return range(1, 151)
    elif runid == 'st11':
        return range(1, 77)
    elif runid == 'st12':
        return range(1, 99)

if len(sys.argv) < 2 :
    print "Usage: %s \"st10|st11|st12\"" % sys.argv[0]
    exit(1)

runid = sys.argv[1]
qids = getQids(runid)

fbdocs = [200,400,600,800]
svddims = [200,100,150,200]

for qid in qids:
    mu = 4000
    for fbdoc in fbdocs:
        for svddim in svddims:
            if runid == 'st10':
                for subqid in [1,2]:
                    for refid in [1,2]:
                        filename = '../sessiontrack_qtfs/%s.q%d.%d.%d.okw.mu%d.fbdocs%d.svddim%d.svm'%(runid, qid, subqid, refid, mu, fbdoc, svddim)
                        if not os.path.exists(filename):
                            print filename
                            jobstr = '%s.q%d.%d.%d.okw.mu%d.fbdocs%d.svddim%d.svm'%(runid, qid, subqid, refid, mu, fbdoc, svddim)
                            jobname = ".jobs/"+jobstr+".job"
                            mu = 4000
                            f = open(jobname, "w")
                            f.write("Universe = vanilla\n")
                            f.write("initialdir = /bos/usr2/gzheng/TermRecall/src\n")
#Usage: ./sessiontrack_qtf_gen <topic ID> <initial_res> <dep> <qrel> <fbdocs> <svddim> <featurefle>
                            f.write("executable = sessiontrack_qtf_gen\n")
                            qrel = None
                            if subqid ==1:
                                qrel = "../qrels/qrels.st10.0.txt"
                            elif subqid==2:
                                qrel = "../qrels/qrels.st10.1.txt"
                                
                            f.write("arguments = " + str(qid) + " ../clueweb09_res/st10/q" + str(qid)+"."+str(refid)+".okw.mu"+str(mu)+".res " + "../parses/st10/"+str(qid)+"."+str(subqid)+".dep " + qrel + " " + str(fbdoc) + " " + str(svddim) + " "+filename+"\n")
                            f.write("output = .jobs/"+jobstr+".out\n")
                            f.write("log = .jobs/"+jobstr+".log\n")
                            f.write("error = .jobs/"+jobstr+".err\n")
                            f.write("queue\n")
                            f.close()
                            os.system("condor_submit "+ jobname)            
                        
            else: # st11 and st12
                res_files = glob.glob('../clueweb09_res/catB_sf/%s/q%d.*mu%d*'%(runid,qid,mu))
                
                for subqid in range(0, len(res_files)):
#                for subqid in [0]:
                    filename = '../sessiontrack_qtfs/%s.q%d.%d.okw.mu%d.fbdocs%d.svddim%d.svm'%(runid, qid, subqid, mu, fbdoc, svddim)
                    res_file = None
                    qrel = '../qrels/qrels.%s.txt' % runid

                    # watch for spam filtered version
                    if subqid == 0:
                        res_file = '../clueweb09_res/catB_sf/%s/q%d.okw.mu%d.res'%(runid,qid,mu)
                    else:
                        res_file = '../clueweb09_res/catB_sf/%s/q%d.%d.okw.mu%d.res'%(runid,qid,subqid,mu)

                    if not os.path.exists(filename):
                        print filename
                        jobstr = '%s.q%d.%d.okw.mu%d.fbdocs%d.svddim%d.svm.%s'%(runid, qid, subqid, mu, fbdoc, svddim, strftime('%Y%m%d'))
                        jobname = ".jobs/"+jobstr+".job"
                        f = open(jobname, "w")
                        f.write("Universe = vanilla\n")
                        f.write("initialdir = /bos/usr2/gzheng/TermRecall/src\n")
                        f.write("executable = sessiontrack_qtf_gen\n")
                        f.write("arguments = " + str(qid) + " " + res_file + " ../parses/"+runid+"/"+str(qid)+".phrase " + qrel + " " + str(fbdoc) + " " + str(svddim) + " "+filename+"\n")
                        f.write("output = .jobs/"+jobstr+".out\n")
                        f.write("log = .jobs/"+jobstr+".log\n")
                        f.write("error = .jobs/"+jobstr+".err\n")
                        f.write("queue\n")
                        f.close()
                        os.system("condor_submit "+ jobname)            
                        

                    
