# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import sys
from collections import defaultdict

if len(sys.argv)!=2:
    print 'Usage: %s <input_svm>' % sys.argv[0]
    exit(0)

train_in=open(sys.argv[1], 'r')
A_out=open('%s.A'%sys.argv[1], 'w')
y_out=open('%s.y'%sys.argv[1], 'w')
B_out=open('%s.B'%sys.argv[1], 'w')

d=defaultdict(list)

for line in train_in:
    qid = line.strip().split('\t')[-1]
#    print qid,
    parts = line.strip().split('#',1)[0].split(' ')
    y = float(parts[0])
    y_out.write('%f\n' % y)

    for part in parts:
        if ':' in part:
            value = float(part.split(':')[-1])
            A_out.write('%f ' % value)

    A_out.write('\n')
    d[qid].append(line.strip())

def subtract(line_a, line_b):
    tple_a = ()
    tple_b = ()
    part_a = line_a.strip().split('#',1)[0].split(' ')
    part_b = line_b.strip().split('#',1)[0].split(' ')
    for part in part_a:
        if ':' in part:
            value = float(part.split(':')[-1])
            tple_a = tple_a + (value,)

    for part in part_b:
        if ':' in part:
            value = float(part.split(':')[-1])
            tple_b = tple_b + (value,)

#    print tple_a
#    print tple_b
    res = ()
    # NOTE BIGRAM - TERM HERE!!!
    for i in range(0, len(tple_a)):
        res = res + ((tple_b[i] - tple_a[i]),)

    return res

    
for k in d:
    size = len(d[k])
    for i in range(0,size):
        for j in range(i,size):
            if i!=j:
                line_a = d[k][i]
                line_b = d[k][j]

                part_a = line_a.split('\t')[-2]
                part_b = line_b.split('\t')[-2]
                if not part_a.startswith('#') and part_b.startswith('#'):
                    terms_b = part_b.split('(')[-1].split(')')[0].split(' ')
                    if part_a in terms_b:
                        res = subtract(line_a, line_b)
                        for val in res:
                            B_out.write('%f ' % val)
                        B_out.write('\n')
                    
                if part_a.startswith('#1') and part_b.startswith('#uw'):
                    string_a = part_a.split('(')[-1].split(')')[0]
                    string_b = part_b.split('(')[-1].split(')')[0]
                    if string_a == string_b:
                        res = subtract(line_a, line_b)
                        for val in res:
                            B_out.write('%f ' % val)
                        B_out.write('\n')

                

    


