# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import subprocess
import os
import glob

trains=[3,5,7,9,11]

for train in trains:
    s = '../svm/t%s*' % train
    test = train + 1
    for svmfile in glob.glob(s):
        svmfilename = svmfile.split('/')[-1]
        svmtestfilename = 't%s.' % test + svmfilename.split('.',1)[1]

        reader = open(svmfile,'r')
        writer = open('../svm_P/' + svmfilename, 'w')
        for line in reader:
            splits = line.split(' ', 1)
            oddp = float(splits[0])
            p = oddp / (oddp + 1.0)
            writer.write('%f %s' % (p, splits[1]))

        writer.close()
        reader.close()


        reader = open('../svm/' + svmtestfilename,'r')
        writer = open('../svm_P/' + svmtestfilename, 'w')
        for line in reader:
            splits = line.split(' ', 1)
            oddp = float(splits[0])
            p = oddp / (oddp + 1.0)
            writer.write('%f %s' % (p, splits[1]))

        writer.close()
        reader.close()
        
        os.system("../libsvm-3.14/svm-scale -l -u -s ../svm_rescale/%s.param ../svm_P/%s > ../svm_rescale/%s.rescale" % (svmfilename, svmfilename, svmfilename))
        os.system("../libsvm-3.14/svm-scale -r ../svm_rescale/%s.param ../svm_P/%s > ../svm_rescale/%s.rescale" % (svmfilename, svmtestfilename, svmtestfilename))
        jobstr = svmfilename
        jobname = ".jobs/" + svmfilename + ".job"
        f = open(jobname, "w")
        f.write("Universe = vanilla\n")
        f.write("initialdir = /bos/usr2/gzheng/TermRecall/src\n")
        f.write("executable = /opt/python27/bin/python\n")
        f.write("arguments = ../libsvm-3.14/tools/gridregression.py -out ../out/%s ../svm_rescale/%s.rescale\n " % (svmfilename, svmfilename))
        f.write("output = .jobs/"+jobstr+".out\n")
        f.write("log = .jobs/"+jobstr+".log\n")
        f.write("error = .jobs/"+jobstr+".err\n")
        f.write("queue\n")
        f.close()
        os.system("condor_submit "+ jobname)
        
