# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import os
import sys
import subprocess

if len(sys.argv) < 2:  
    print 'Usage: %s <trec_topics.txt>' % (sys.argv[0])
    sys.exit()

print '<parameters>'
with open(sys.argv[1], 'r') as topics_in:
    desc = ''
    begin_desc = False
    for line in topics_in:

        if line.startswith('<num>'):
            qid = int(line.strip().split(':')[-1])
        elif line.startswith('<desc>'):
            begin_desc = True
        elif line.startswith('<narr>'):
            desc = desc.replace('\n', ' ')
            ofile= open('_tmp.q','w')
            ofile.write('%s\n'%desc)
            ofile.close();

            processed_query = subprocess.check_output(('./remove_metaterms.pl _tmp.q').split(' ')).strip()
            print '  <query><type>indri</type><number>%d</number><text>\n    #combine(%s)\n  </text></query>' %(qid, processed_query)

            desc = ''
            begin_desc = False
        elif begin_desc:
            desc += line
    
print '</parameters>'
