# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import sys
import glob
from collections import defaultdict

def oddp2p(oddp):
    return oddp / (oddp+1.0)


if (len(sys.argv) != 5):
    print 'Usage: %s <qid_start> <qid_end> <qtf_dir> <query_output_file>' % sys.argv[0]
    print '       [qid_start, qid_end], inclusive'
    exit(0)

qid_start = int(sys.argv[1])
qid_end = int(sys.argv[2])
qtfs_dir = sys.argv[3]

query_output = open(sys.argv[4], 'w')

query_output.write('<parameters>\n')
for qid in range(qid_start, qid_end +1):
    query_output.write('\t<query><type>indri</type><number>%d</number><text>\n' % qid)
    query_output.write('#weight(\n')

    for filename in glob.glob('%s/q%d*.true.recall'%(qtfs_dir, qid)): # should return a list of same files with different fbdoc and svddim and take the first one
        with open(filename, 'r') as qid_in:
            for line in qid_in:
                parts = line.split('#', 1)
                oddp = float(parts[0])
                p = oddp2p(oddp)
                query_expr = parts[1].split('\t')[1]
                query_output.write('\t%f %s\n' % (p, query_expr))
        break
    
    query_output.write(' )\n')
    query_output.write('\t</text></query>\n')
    
query_output.write('</parameters>\n')

query_output.close()
