# ==========================================================================
#  Copyright (c) 20014 Carnegie Mellon University.  All Rights Reserved.
# 
#  Use of the Lemur Toolkit for Language Modeling and Information Retrieval
#  is subject to the terms of the software license set forth in the LICENSE
#  file included with this software (and below), and also available at
#  http://www.lemurproject.org/license.html
# 
# ==========================================================================

import sys
import os
import subprocess
import ast

if len(sys.argv)!=4:
    print 'Usage: %s <input.part> <index> <output.wsd>' % sys.argv[0]
    exit(0)

DUMP_INDEX_CMD = '/bos/usr0/gzheng/.local/bin/dumpindex'
NGRAM_PATH = '/bos/tmp17/gzheng/google_ngram_leveldb'
AOL_GOV_PATH = '/bos/tmp17/gzheng/aol-gov_index'
AOL_U500K_PATH = '/bos/tmp17/gzheng/aol-u500k_index'
ENWIKI_PATH = '/bos/tmp17/gzheng/enwiki-titles_index'

qid = int(sys.argv[1].split('/')[-1].split('.')[0])

AOL_PATH = AOL_U500K_PATH

#ngram_command = '/bos/tmp17/gzheng/query_google_ngram_leveldb %s %s.tmp > %s.nc' % (NGRAM_PATH, sys.argv[1], sys.argv[1])
#os.system(ngram_command)

with open(sys.argv[1], 'r') as part_in, open('%s.gnc' % sys.argv[1], 'r') as part_nc, open(sys.argv[3], 'w') as part_svm:
    for line in zip(part_in, part_nc):
        expr = line[0].strip()
        ngram_count = int(ast.literal_eval(line[1].split('\t')[-1]))
        
        wiki_cmd = '%s %s dx %s' % (DUMP_INDEX_CMD, ENWIKI_PATH, expr)
        wiki_out = subprocess.check_output(wiki_cmd.split(' ', 3))
        wiki_count = int(ast.literal_eval(wiki_out.strip().split(':')[-1]))
        
        aol_cmd = '%s %s dx %s' % (DUMP_INDEX_CMD, AOL_PATH, expr)
        aol_out = subprocess.check_output(aol_cmd.split(' ', 3))
        aol_count = int(ast.literal_eval(aol_out.strip().split(':')[-1]))

        index = sys.argv[2]
        ctf_cmd = '%s %s x %s' % (DUMP_INDEX_CMD, index, expr)
        ctf_out = subprocess.check_output(ctf_cmd.split(' ', 3))
        ctf_count = int(ast.literal_eval(ctf_out.strip().split(':')[-1]))

        df_cmd = '%s %s dx %s' % (DUMP_INDEX_CMD, index, expr)
        df_out = subprocess.check_output(ctf_cmd.split(' ', 3))
        df_count = int(ast.literal_eval(ctf_out.strip().split(':')[-1]))

        # output wsd features as described in "Parameterized Concept Weighting in Verbose Queries"
        # GF, WF, QF, CF, DF, AP ( default AP = 1)
        ap = 1
        part_svm.write('%d %d %d %d %d %d #%s\t%d\n' % (ngram_count, wiki_count, aol_count, ctf_count, df_count, ap, expr, qid))
        
        



