import subprocess
import os
import sys
import glob

def oddstop(odds):
    if odds < 0.01:
        odds = 0.01

    return odds / (odds + 1.0)

if(len(sys.argv) !=3):
    print 'Usage: %s <svm_file> <out_file>'%(sys.argv[0])
    exit(1)

svm_file = open(sys.argv[1],'r')
out_file = open(sys.argv[2],'r')
svm_values = []
out_values = []
bias_values = []

for line in svm_file:
    parts = line.split(' ',1)
    odds = float(parts[0])
    label = odds / (odds + 1.0)
    svm_values.append((label, parts[1].strip()))

svm_file.close()

for line in out_file:
    odds = float(line)
    label = oddstop(odds)
    out_values.append(label)

out_file.close()

l1_err = 0
l2_err = 0
for i in range(0,len(svm_values)):
    bias = abs(svm_values[i][0] - out_values[i])
    bias_values.append((bias,svm_values[i][1]))
    l1_err += bias
    l2_err += bias * bias

print len(svm_values)
print len(out_values)
bias_values.sort(reverse=True)


xl1 = 0
xl2 = 0
for i in range(0,len(svm_values)):
    if(bias_values[i][0]> l1_err / len(svm_values)):
        xl1 +=1

    if(bias_values[i][0]> 2*l1_err / len(svm_values)):
        xl2 +=1
    
    print bias_values[i]

print 'Average L1 loss: %f '% (l1_err / len(svm_values))
print 'Average L2 loss: %f '% (l2_err / len(svm_values))
print xl1
print xl2
