from random import shuffle

def k_fold_cv(items, k, randomize=False):
    if randomize:
        items = list(items)
        shuffle(items)

    slices = [items[i::k] for i in xrange(k)]

    for i in xrange(k):
        validation = slices[i]
        training = [item
                    for s in slices if s is not validation
                    for item in s]
        yield training, validation


if __name__ == '__main__':
    items = range(50)
    for training, validation in k_fold_cv(items, 5):
        print training, validation
