#!/bin/bash

QTFS_PREFIX="../qtfs_20140607_stopped_sd_CIKM"
TMP_PREFIX="../tmp_20140607_stopped_sd_CIKM"

vectors=("trec7" "wt10g" "gov2" "clueweb100" "clueweb300" "clueweb500" "google300")
models=("/bos/tmp17/gzheng/trec7-300.bin" "/bos/tmp17/gzheng/wt10g-300.bin" "/bos/tmp17/gzheng/gov2-new-300.bin" "/bos/tmp17/gzheng/clueweb09b-new-100.bin" "/bos/tmp17/gzheng/clueweb09b-new-300.bin" "/bos/tmp17/gzheng/clueweb09b-new-500.bin" "/bos/usr0/gzheng/TermRecall/src/word2vec/GoogleNews-vectors-negative300.bin")
dims=(300 300 300 100 300 500 300)

# make up all the directories and generate the features
for ((i=0;i<${#vectors[@]};i++))
do
    vector=${vectors[$i]}
    mkdir -p ${QTFS_PREFIX}-${vector}
    model=${models[$i]}
    dim=${dims[$i]}
    python word2vec_feature.py ${model} ${dim} ${QTFS_PREFIX}-${vector} 0

    mkdir -p ${TMP_PREFIX}-${vector}
    mkdir -p ${TMP_PREFIX}-${vector}_mix
    mkdir -p ${TMP_PREFIX}-${vector}_bm25
    mkdir -p ${TMP_PREFIX}-${vector}_mix_bm25
done
