from Constants import *
import os
import subprocess
import glob

def tid2range(tid):
    if tid==35:
        return (151, 300)
    if tid==37:
        return (151, 400)
    if tid==39:
        return (151, 500)

    if tid==13 or tid==14:
        tid+=1

    return (tid*50+1, tid*50 + 50)

def qid2trecid(qid):
    if qid>700:
        qid-=50

    return (qid-1)/50


def get_test_tid(tid):
    if tid==35:
        return 6
    if tid==37:
        return 8
    if tid==39:
        return 10
    else:
        return tid+1

def eval_svm(train_qids, test_qids, run_tag, nsample=None):
    oddp_tag = '_oddp' if '.oddp' in run_tag else ''
    prob_tag = ' -b 1 ' if '.oddp' not in run_tag else ' '
    nsample_tag = '.nsample.%d' % nsample if not nsample == None else ''
    
    test_prf_flag = False
    if run_tag == '.rf.prf':
        test_prf_flag = True
        run_tag = '.rf'

    train_qids.sort()
    svmname = None
    if train_qids[-1]-train_qids[0]+1 != len(train_qids):
        for index in xrange(len(train_qids)):
            if train_qids[index]-train_qids[0]!=index:
                svmname = 'q%d-%d-%d.%d.desc.fbdoc???.svddim???%s%s'%(train_qids[0],train_qids[index],train_qids[-1], len(train_qids), run_tag,nsample_tag)
                break
    else:
        svmname = 'q%d-%d.%d.desc.fbdoc???.svddim???%s%s'%(train_qids[0],train_qids[-1], len(train_qids), run_tag, nsample_tag)

    svmname_prefix = svmname.split('.fbdoc')[0]

    # get the best result 
    svm_result_list = []
    for filename in glob.glob('../out/%s.out'%svmname):
        parts = filename.split('/')[-1].split('.')
        fbdoc = int(parts[3].split('fbdoc')[1])
        svddim = int(parts[4].split('svddim')[1])

        if fbdoc not in fbdocs or svddim not in svddims:
#        if fbdoc not in good_fbdocs or svddim not in good_svddims:
                continue
        
        r = open(filename, 'r')
        for line in r:
            splits = line.strip().split(' ')
            c = float(splits[0])
            g = float(splits[1])
            p = float(splits[2])
            mse = float(splits[3])
            svm_result_list.append((mse, (fbdoc, svddim, c, g, p)))
        r.close()
    
    svm_result_list.sort()
    best_fbdoc = svm_result_list[0][1][0]
    best_svddim = svm_result_list[0][1][1]
    best_c = 2**svm_result_list[0][1][2]
    best_g = 2**svm_result_list[0][1][3]
    best_p = 2**svm_result_list[0][1][4]

    # print best_fbdoc, best_svddim, best_c, best_g, best_p
    print ' CV_MSE:%f' %svm_result_list[0][0],

    # get test examples ready
    # create test samples every time
    # Note, different settings would overwite them!
    trainsvmname = '%s.fbdoc%d.svddim%d%s%s'%(svmname_prefix, best_fbdoc, best_svddim, run_tag, nsample_tag)

    # CHANGE HERE
    ofilename = '../tmp/%s.fbdoc%d.svddim%d%s%s.test.svm'%(svmname_prefix, best_fbdoc, best_svddim, run_tag, nsample_tag)
    ofile = open(ofilename, 'w')
    for qid in test_qids:
        trecid = qid2trecid(qid)
        mu = mus[trecid]
        ifilename = ''
        if run_tag == '' or run_tag == '.oddp':
            ifilename = '../qtfs%s/q%d.okw.desc.mu%d.fbdocs%d.svddim%d.svm'%(oddp_tag, qid, mu, best_fbdoc, best_svddim)
        elif run_tag == '.rf' or run_tag == '.rf.oddp':
            if test_prf_flag:
                ifilename = '../qtfs%s/q%d.okw.desc.mu%d.fbdocs%d.svddim%d.svm'%(oddp_tag, qid, mu, best_fbdoc, best_svddim)
            else:
                ifilename = '../qtfs%s/q%d.okw.desc.fbdocs%d.svddim%d.rf.svm'%(oddp_tag, qid, best_fbdoc, best_svddim)
        elif run_tag == '.resample' or run_tag == '.resample.oddp':
            ifilename = '../qtfs_linear%s/q%d.okw.desc.mu%d.fbdocs%d.svddim%d.nsample.%d.svm'%(oddp_tag, qid, mu, best_fbdoc, best_svddim, nsample)
        elif run_tag == '.reweighted':
              ifilename = '../qtfs_linear%s/q%d.okw.desc.mu%d.fbdocs%d.svddim%d.reweighted.svm'%(oddp_tag, qid, mu, best_fbdoc, best_svddim)          
        
        # query term feature file not exist
        if not os.path.exists(ifilename):
            continue
            #os.system('./query_term_feature_gen %d ../res/t%d.okw.mu%d.res %d %d %s'%(qid, trecid, mu, fbdoc, svddim, ifilename))
        
        ifile=open(ifilename,'r')
        for line in ifile:
            ofile.write('%s\n'%line.strip())

        ifile.close()

    ofile.close()

    # rescale test files
    os.system('../libsvm-3.14/svm-scale -r ../tmp/%s.rescale.param %s > %s.rescale' % (trainsvmname, ofilename, ofilename))

    #train final svm
    os.system('../libsvm-3.14/svm-train -q -s 3 -c %f -g %f -p %f %s ../tmp/%s.train.svm.rescale ../tmp/%s.model' % (best_c, best_g, best_p, prob_tag, trainsvmname, trainsvmname))
    

    #test it!
    #os.system('../libsvm-3.14/svm-predict %s ../tmp/%s.test.svm.rescale ../tmp/%s.model ../tmp/%s.out' % (prob_tag, trainsvmname, trainsvmname, trainsvmname))
    #CHANGE HERE!
    svmtest_output = subprocess.check_output(('../libsvm-3.14/svm-predict%s%s.rescale ../tmp/%s.model ../tmp/%s.out' % (prob_tag, ofilename, trainsvmname, trainsvmname)).split(' '))
    current_mse = float(svmtest_output.strip().split('Mean squared error = ')[1].split(' ')[0])
    print 'MSE: '+str(current_mse),

    #generate weighted query
    # oddp
    if prob_tag == ' ':
        os.system('./wqg_oddP ../tmp/%s.test.svm ../tmp/%s.out ../tmp/%s.q'% (trainsvmname, trainsvmname, trainsvmname))
    # p
    else:
        os.system('./wqg_P ../tmp/%s.test.svm ../tmp/%s.out ../tmp/%s.q'% (trainsvmname, trainsvmname, trainsvmname))

    #NOTE HERE:
    #Test qids should be in the same trec dataset!!!
    trecid = qid2trecid(test_qids[0])

    #search the query!
    os.system('/bos/usr2/gzheng/.local/bin/IndriRunQuery /bos/tmp4/lezhao/gov2/queries/stoplist.param -count=1000 ../tmp/%s.q -index=/bos/tmp17/gzheng/trec/indext%d-v5.3/ -trecFormat=t -rule=method:d,mu:%d > ../res/%s.res' %(trainsvmname, trecid, mus[trecid], trainsvmname))
    
    #evaluate the results!
    eval_output = subprocess.check_output(('./trec_eval ../qrels/qrels.t%d.txt ../res/%s.res' %(trecid, trainsvmname)).split(' '))

    eval_map = eval_output.strip().split('\n')[5]
    print 'MAP: '+str(float(eval_map.split('\t')[-1])),
    print '   BEST_FBDOC:%d BEST_SVDDIM:%d' % (best_fbdoc, best_svddim)

def eval_best_svm(train_qids, test_qids, run_tag, argstr):
    if run_tag == '.resample' or run_tag == '.resample.oddp':
        for nsample in range(1,31):
            print '%s %d:'%(argstr, nsample),
            eval_svm(train_qids,  test_qids, run_tag, nsample)
    else:
        print argstr+':',
        eval_svm(train_qids,  test_qids, run_tag)


def process(argstr):
    args = argstr.split(' ')
    train_qids = []
    test_qids = []
    run_tag = ''
    
    for arg in args:
        if arg.startswith("TRAIN"):
            start_qid = int(arg.split(':')[1].split('-')[0])
            end_qid = int(arg.split(':')[1].split('-')[1])
            train_qids += range(start_qid, end_qid+1)
        elif arg.startswith("TEST"):
            start_qid = int(arg.split(':')[1].split('-')[0])
            end_qid = int(arg.split(':')[1].split('-')[1])
            test_qids += range(start_qid, end_qid+1)
        elif arg == 'ODDP':
            run_tag = '.oddp'
        elif arg == 'RF':
            run_tag = '.rf'
        elif arg == 'RESAMPLE':
            run_tag = '.resample'
        elif arg == 'REWEIGHTED':
            run_tag = '.reweighted'
        elif arg == 'RF.ODDP':
            run_tag = '.rf.oddp'
        elif arg == 'RESAMPLE.ODDP':
            run_tag = '.resample.oddp'
        elif arg == 'RF.PRF':
            run_tag = '.rf.prf'
        else:
            print 'Train/Test dataset error!'
            exit(1)

    eval_best_svm(train_qids, test_qids, run_tag, argstr)


for trecno in range(3,13,2) + [35, 37, 39]:
#for trecno in range(3,11,2) + [35]:
#for trecno in [35,37]:
    test_tid = get_test_tid(trecno)
    start1 = tid2range(trecno)[0]
    end1 = tid2range(trecno)[1]
    start2 = tid2range(test_tid)[0]
    end2 = tid2range(test_tid)[1]

    #train on trecno, test on trecno+1
    process('TRAIN:%d-%d TEST:%d-%d'%(start1, end1, start2, end2))

    #train on trecno PRF, test on trecno+1 PRF REWEIGHTED
    #process('TRAIN:%d-%d TEST:%d-%d REWEIGHTED'%(start1, end1, start2, end2))
    '''
    #train on trecno RF, test on trecno+1 PRF
    process('TRAIN:%d-%d TEST:%d-%d RF.PRF'%(start1, end1, start2, end2))
    
    #train on trecno, test on trecno+1, True RF
    process('TRAIN:%d-%d TEST:%d-%d RF'%(start1, end1, start2, end2))

    #train on trecno, test on trecno+1, oddP
    process('TRAIN:%d-%d TEST:%d-%d ODDP'%(start1, end1, start2, end2))

    #train on trecno, test on trecno+1, True RF, oddP
    process('TRAIN:%d-%d TEST:%d-%d RF.ODDP'%(start1, end1, start2, end2))
    '''
    #train on trecno, test on trecno+1, resample
    #process('TRAIN:%d-%d TEST:%d-%d RESAMPLE'%(start1, end1, start2, end2))
    '''
    #train on trecno, test on trecno+1, resample, oddP
    process('TRAIN:%d-%d TEST:%d-%d RESAMPLE.ODDP'%(start1, end1, start2, end2))

    for k in range(0,5):
        #train on trecno and trecno+1, test on trecno+1, reweighted
        process('TRAIN:%d-%d TRAIN:%d-%d TRAIN:%d-%d TEST:%d-%d REWEIGHTED'%(start1, end1, start2, start2 + k*10 - 1, start2+k*10+10,end2, start2+k*10,start2+k*10+9))
        continue
        
        #train on trecno+1, test on trecno+1
        process('TRAIN:%d-%d TRAIN:%d-%d TEST:%d-%d'%(start2, start2 + k*10 - 1, start2+k*10+10,end2, start2+k*10,start2+k*10+9))

        #train on trecno+1, test on trecno+1, oddP
        process('TRAIN:%d-%d TRAIN:%d-%d TEST:%d-%d ODDP'%(start2, start2 + k*10 - 1, start2+k*10+10,end2, start2+k*10,start2+k*10+9))

        #train on trecno and trecno+1, test on trecno+1
        process('TRAIN:%d-%d TRAIN:%d-%d TRAIN:%d-%d TEST:%d-%d'%(start1, end1, start2, start2 + k*10 - 1, start2+k*10+10,end2, start2+k*10,start2+k*10+9))

        #train on trecno and trecno+1, test on trecno+1, oddP
        process('TRAIN:%d-%d TRAIN:%d-%d TRAIN:%d-%d TEST:%d-%d ODDP'%(start1, end1, start2, start2 + k*10 - 1, start2+k*10+10,end2, start2+k*10,start2+k*10+9))
   '''


            
