#include "FeatureGenerator.h"
#include <indri/Index.hpp>
#include <vector>
#include <Eigen/Dense>
#include <sstream>

using namespace std;
using namespace indri::index;
using namespace indri::collection;
using namespace Eigen;

std::string str(int a)
{
    std::ostringstream oss;
    oss<<a;
    return oss.str();
}

std::string str(float a)
{
    std::ostringstream oss;
    oss<<a;
    return oss.str();
}
 
int main(int argc, char **argv)
{
    if(argc != 6)
    {
        cout<<"Usage: "<< argv[0]<<" <TREC No.> <initial_res> <fbdocs> <svddim> <featurefle>"<<endl;
        exit(0);
    }

    std::vector<int> data_sets;
    data_sets.push_back(atoi(argv[1]));

    std::string initial_res(argv[2]);
    int fbdocs = atoi(argv[3]);
    int svddim = atoi(argv[4]);
    
    std::ofstream data_out(argv[5], std::ofstream::out);

    for(int i =0;i<data_sets.size();i++)
    {
        int data_set = data_sets[i];
    
        std::string idx = "/bos/tmp17/gzheng/trec/indext" + str(data_set) + "-v5.3";
        std::string qrel = "../qrels/qrels.t" + str(data_set) + ".txt";

        // Handle Trec 13 and Trec 14
        if(data_set >= 13)
            data_set += 1;
        
        for(int qid= data_set * 50 + 1;qid<=data_set * 50 + 50;qid++)
        {

            if(qid==613)
            {
                // 613 bug
                continue;
            }

            cout<<"Processing query "<<qid<<endl;
            std::string dep_res = "../parses/t" + str(data_set) +".desc/" + str(qid) + ".dep";
            
            // Seems now do not need to set query str
            std::string query_str = "";
            FeatureGenerator fg(idx, qid, query_str, initial_res);
            fg.generateTFIDFMatrix(fbdocs);
            fg.compute_concept_matrix(svddim);
            fg.load_qrel(qrel);
            fg.load_dep(dep_res);
            data_out<<fg.generate_svm_features();
            data_out.flush();
        }
    }

    data_out.close();
    
    return 0;
}


