import sys
import os
import subprocess

if len(sys.argv)!=3:
    print 'Usage: %s <input.part> <output.svm>' % sys.argv[0]
    exit(0)

DUMP_INDEX_CMD = '/bos/usr0/gzheng/.local/bin/dumpindex'

NGRAM_PATH = '/bos/tmp17/gzheng/google_ngram_leveldb'
AOL_GOV_PATH = '/bos/tmp17/gzheng/aol-gov_index'
AOL_U500K_PATH = '/bos/tmp17/gzheng/aol-u500k_index'
ENWIKI_PATH = '/bos/tmp17/gzheng/enwiki-titles_index'

qid = int(sys.argv[1].split('/')[-1].split('.')[0])

if (qid >=551 and qid <= 650) or (qid >= 701 and qid <= 800):
    AOL_PATH = AOL_GOV_PATH
else:
    AOL_PATH = AOL_U500K_PATH


with open(sys.argv[1], 'r') as part_in, open('%s.tmp' % sys.argv[1], 'w') as part_tmp:
    for line in part_in:

        if line.startswith('#'):
            part_tmp.write('%s\n' % line.strip().split('(')[1].split(')')[0])
        else:
            part_tmp.write('%s\n' % line.strip())

ngram_command = '/bos/tmp17/gzheng/query_google_ngram_leveldb %s %s.tmp > %s.gnc' % (NGRAM_PATH, sys.argv[1], sys.argv[1])
os.system(ngram_command)
print '%s done' % sys.argv[1]
exit(0)

with open(sys.argv[1], 'r') as part_in, open('%s.tmp.gnc' % sys.argv[1], 'r') as part_nc, open(sys.argv[2], 'w') as part_svm:
    for line in zip(part_in, part_nc):
        expr = line[0].strip()
        ngram_count = int(line[1].split('\t')[-1])
        
        wiki_cmd = '%s %s dx %s' % (DUMP_INDEX_CMD, ENWIKI_PATH, expr)
        wiki_out = subprocess.check_output(wiki_cmd.split(' ', 3))
        wiki_count = int(wiki_out.strip().split(':')[-1])
        
        aol_cmd = '%s %s dx %s' % (DUMP_INDEX_CMD, AOL_PATH, expr)
        aol_out = subprocess.check_output(aol_cmd.split(' ', 3))
        aol_count = int(aol_out.strip().split(':')[-1])
        
        part_svm.write('%d %d %d #%s\n' % (ngram_count, wiki_count, aol_count, expr))
        
        



