from condor_cv_svm import *
import sys

train_file = sys.argv[1]
dev_file = sys.argv[2]
test_file = sys.argv[3]
run_tag = ''
test_qids=[]
test_qids.append(int(sys.argv[4]))
# CONDOR PART STARTS

# svmlight
for gamma in gammas:
    os.system('./svm_learn -v 0 -z r -t 2 -g %d %s.rescale %s.model' % (gamma, train_file, train_file))

    # test on dev used to do CV
    # we can also do test on testing so that we do not to do again after we have chose the right params
    os.system('./svm_classify -v 0 %s.rescale %s.model %s.out' % ( dev_file, train_file, dev_file))
    os.system('./svm_classify -v 0 %s.rescale %s.model %s.out' % ( test_file, train_file, test_file))
    
#generate weighted query
    oddp_tag = '_oddp' if '.oddp' in run_tag else ''
    prob_tag = ' -b 1 ' if '.oddp' not in run_tag else ' '
    
# oddp
    if prob_tag == ' ':
        os.system('./wqg_oddP %s %s.out %s.q'% (test_file, test_file, test_file))
        os.system('./wqg_oddP %s %s.out %s.q'% (dev_file, dev_file, dev_file))
# p
    else:
        os.system('./wqg_P %s %s.out %s.q' % (test_file, test_file, test_file))
        os.system('./wqg_P %s %s.out %s.q' % (dev_file, dev_file, dev_file))
        
#NOTE HERE:
#Test qids should be in the same trec dataset!!!
        trecid = qid2trecid(test_qids[0])
        
#search the query!
        os.system('/bos/usr2/gzheng/.local/bin/IndriRunQuery /bos/tmp4/lezhao/gov2/queries/stoplist.param -count=1000 %s.q -index=/bos/tmp17/gzheng/trec/indext%d-v5.3/ -trecFormat=t -rule=method:d,mu:%d > ../res/%s.res' %(dev_file, trecid, mus[trecid], dev_file.split('/')[-1]))
        os.system('/bos/usr2/gzheng/.local/bin/IndriRunQuery /bos/tmp4/lezhao/gov2/queries/stoplist.param -count=1000 %s.q -index=/bos/tmp17/gzheng/trec/indext%d-v5.3/ -trecFormat=t -rule=method:d,mu:%d > ../res/%s.res' %(test_file, trecid, mus[trecid], test_file.split('/')[-1]))
        
#evaluate the results!
        eval_output_dev = subprocess.check_output(('./trec_eval ../qrels/qrels.t%d.txt ../res/%s.res' %(trecid, dev_file.split('/')[-1])).split(' '))
        eval_output_test = subprocess.check_output(('./trec_eval ../qrels/qrels.t%d.txt ../res/%s.res' %(trecid, test_file.split('/')[-1])).split(' '))

        eval_map_dev = float(eval_output_dev.strip().split('\n')[5].split('\t')[-1])
        eval_map_test = float(eval_output_test.strip().split('\n')[5].split('\t')[-1])
        
        print '%s\t%s\t%s\t%f\t%f\t%f' % (train_file, dev_file, test_file, eval_map_dev, eval_map_test, gamma)

# CONDOR PART ENDS
