from condor_cv_svm import *
from compute_prediction_error import *
import sys

train_file = sys.argv[1]
dev_file = sys.argv[2]
test_file = sys.argv[3]
run_tag = ''
test_qids=[]
test_qids.append(int(sys.argv[4]))
# CONDOR PART STARTS

# svmlight
for gamma in [1.5]:
    # RBF kernel
    os.system('./svm_learn -v 0 -z r -t 2 -g %f %s %s.model' % (gamma, train_file, train_file))

    # linear kernel
    #os.system('./svm_learn -v 0 -z r -t 0 %s %s.model' % (train_file, train_file))

    # test on dev used to do CV
    # we can also do test on testing so that we do not to do again after we have chosen the right params
    os.system('./svm_classify -v 0 %s %s.model %s.out' % ( dev_file, train_file, dev_file))
    os.system('./svm_classify -v 0 %s %s.model %s.out' % ( test_file, train_file, test_file))
    
#generate weighted query
    oddp_tag = '_oddp' if '.oddp' in run_tag else ''
    prob_tag = ' -b 1 ' if '.oddp' not in run_tag else ' '

# force constraints, naive way by just adding weights up
# TO DO
    #os.system('/opt/python27/bin/python wqg_oddP_sum.py %s %s.out %s.q'% (test_file, test_file, test_file))
    #os.system('/opt/python27/bin/python wqg_oddP_sum.py %s %s.out %s.q'% (dev_file, dev_file, dev_file))

# note the wqg_oddP
    os.system('./wqg_oddP %s %s.out %s.q'% (test_file, test_file, test_file))
    os.system('./wqg_oddP %s %s.out %s.q'% (dev_file, dev_file, dev_file))
        
#NOTE HERE:
#Test qids should be in the same trec dataset!!!
    trecid = qid2trecid(test_qids[0])
        
#search the query!
    os.system('/bos/usr2/gzheng/Boolean/app-4.10/IndriRunQuery -count=1000 %s.q -index=/bos/tmp17/gzheng/trec/indext%d-v4.10/ -trecFormat=t -rule=method:d,mu:%d > ../res/%s.res' %(dev_file, trecid, mus[trecid], dev_file.split('/')[-1]))
    os.system('/bos/usr2/gzheng/Boolean/app-4.10/IndriRunQuery -count=1000 %s.q -index=/bos/tmp17/gzheng/trec/indext%d-v4.10/ -trecFormat=t -rule=method:d,mu:%d > ../res/%s.res' %(test_file, trecid, mus[trecid], test_file.split('/')[-1]))
    
#evaluate the results!
    eval_output_dev = subprocess.check_output(('./trec_eval ../qrels/qrels.t%d.txt ../res/%s.res' %(trecid, dev_file.split('/')[-1])).split(' '))
    eval_output_test = subprocess.check_output(('./trec_eval ../qrels/qrels.t%d.txt ../res/%s.res' %(trecid, test_file.split('/')[-1])).split(' '))
    
    eval_map_dev = float(eval_output_dev.strip().split('\n')[5].split('\t')[-1])
    eval_map_test = float(eval_output_test.strip().split('\n')[5].split('\t')[-1])

    weighted_prediction_error_dev  = compute_err(dev_file,  '%s.out'%dev_file)
    weighted_prediction_error_test = compute_err(test_file, '%s.out'%test_file)

    prediction_error_dev = compute_err_raw(dev_file, '%s.out' % dev_file)
    prediction_error_test= compute_err_raw(test_file, '%s.out'% test_file)
    
    print '%s\t%s\t%s\t%f\t%f\t%f\t%f\t%f\t%f\t%f' % (train_file, dev_file, test_file, eval_map_dev, eval_map_test, gamma, weighted_prediction_error_dev, weighted_prediction_error_test, prediction_error_dev, prediction_error_test)
    
# CONDOR PART ENDS
