#include "FeatureGenerator.h"
#include <indri/Index.hpp>
#include <vector>
#include <Eigen/Dense>

using namespace std;
using namespace indri::index;
using namespace indri::collection;
using namespace Eigen;
 
int main()
{
    std::string idx = "/bos/tmp17/gzheng/trec/indext12-v5.3";
    std::string initial_res = "/bos/usr2/gzheng/TermRecall/res/t12.okw.mu900.res";
    std::string dep_res = "/bos/usr2/gzheng/Boolean/parses/t12/613.dep";
    std::string query_str = "Coping with overcrowded prisons";
    std::string qrel_file = "/bos/usr2/gzheng/TermRecall/qrels/qrels.t12.txt";
    FeatureGenerator fg(idx, 613, query_str, initial_res);
    int docid;
    std::string phrase("#1(what is)");
    while(cin>>docid)
    {
        cout<<docid<<" "<<phrase<<endl;
        cout<<fg.computeExpressionTf(phrase,docid)<<endl;
    }

    /*
    fg.generateTFIDFMatrix(180);
    
    fg.compute_concept_matrix(150);
    fg.load_qrel(qrel_file);
    fg.load_dep(dep_res);

    string tterm;
    int qid;
    while(cin>>tterm)
    {
        string stem = fg.stem_it(tterm);
        cout<<"Stem of "<<tterm<<":"<<stem<<endl;
        float rc = fg.compute_true_recall(stem);
        cout<<"True recall of "<<tterm<<":"<<rc/(1-rc)<<endl;
        float centra = fg.compute_term_centrality(stem);
        cout<<"Term centrality "<<tterm<<":"<<centra<<endl;
        float ccentra = fg.compute_concept_centrality(stem);
        cout<<"Concept centrality "<<tterm<<":"<<ccentra<<endl;
        float rep = fg.compute_replaceability(stem);
        cout<<"Term Replaceability "<<tterm<<":"<<rep<<endl;
        float abs = fg.compute_abstractness(stem);
        cout<<"Term abstractness "<<tterm<<":"<<abs<<endl;
    }
    
    return 0;
    */
}
