#include "FeatureGenerator.h"
#include <indri/Index.hpp>
#include <vector>
#include <Eigen/Dense>
#include <sstream>

using namespace std;
using namespace indri::index;
using namespace indri::collection;
using namespace Eigen;

std::string str(int a)
{
    std::ostringstream oss;
    oss<<a;
    return oss.str();
}

std::string str(float a)
{
    std::ostringstream oss;
    oss<<a;
    return oss.str();
}


int main(int argc, char **argv)
{
    if(argc != 11)
    {
        cout<<"Usage: "<< argv[0]<<" <Query ID> <initial_res> <idx> <plsa_stem> <plsa_wt> <qrels> <dep> <fbdocs> <svddim> <featurefle>"<<endl;
        exit(0);
    }

    int qid = atoi(argv[1]);
    std::string initial_res(argv[2]);
    std::string idx_path(argv[3]);
    std::string stem_dict_path(argv[4]);
    std::string plsa_wt(argv[5]);
    std::string qrel_path(argv[6]);
    std::string dep_res(argv[7]);
    int fbdocs = atoi(argv[8]);
    int svddim = atoi(argv[9]);
    std::ofstream data_out(argv[10], std::ofstream::out);

    cout<<"Processing query: "<<qid<<" fbdocs: "<<fbdocs<<" svddim: "<<svddim<<endl;
    // Seems now do not need to set query str
    std::string query_str = "";
    FeatureGenerator fg(idx_path, qid, query_str, initial_res);
    fg.generateTFIDFMatrix(fbdocs);
    fg.load_plsa_result(plsa_wt, stem_dict_path);
    //fg.compute_concept_plsa_matrix(svddim);
    fg.load_qrel(qrel_path);
    fg.load_dep(dep_res);
    data_out<<fg.generate_svm_features();
    data_out.flush();
    data_out.close();
    
    return 0;
}


