#include "FeatureGenerator.h"
#include <indri/Index.hpp>
#include <vector>
#include <Eigen/Dense>
#include <sstream>

using namespace std;
using namespace indri::index;
using namespace indri::collection;
using namespace Eigen;

std::string str(int a)
{
    std::ostringstream oss;
    oss<<a;
    return oss.str();
}

std::string str(float a)
{
    std::ostringstream oss;
    oss<<a;
    return oss.str();
}


int main(int argc, char **argv)
{
    if(argc != 8)
    {
        cout<<"Usage: "<< argv[0]<<" <Query ID> <initial_res> <idx> <qrel> <dep> <fbdocs> <featurefle>"<<endl;
        exit(0);
    }

    int qid = atoi(argv[1]);
    std::string initial_res(argv[2]);
    std::string idx_path(argv[3]);
    std::string qrel_path(argv[4]);
    std::string dep_res(argv[5]);
    int fbdocs = atoi(argv[6]);
    std::ofstream data_out(argv[7], std::ofstream::out);

    cout<<"Processing query: "<<qid<<" fbdocs: "<<fbdocs<<endl;
    // Seems now do not need to set query str
    std::string query_str = "";
    FeatureGenerator fg(idx_path, qid, query_str, initial_res);

    // Note the different use here
    // usage 1:
    fg.generateTFIDFMatrix(fbdocs);
    fg.setNumOfTopDocuments(fbdocs);

    // Usage 2:
    //fg.generateTFIDFMatrix(1000);
    //fg.setNumOfTopDocuments(fbdocs);

    //fg.compute_concept_matrix(svddim);

    //fg.saveTFIDFDataMatrix(out_file);
    //fg.compute_concept_plsa_matrix(svddim);
    fg.load_qrel(qrel_path);
    fg.load_dep(dep_res);
    data_out<<fg.generate_pr_recall_query();
    data_out.flush();
    data_out.close();
    
    return 0;
}


