from Constants import *
import subprocess
import os
import glob
import sys
from time import strftime

def getRunStr(rid):
    if rid==1:
        return "wsj87-91"
    elif rid==2:
        return "wsj92"
    elif rid==3:
        return "ap88-89"
    elif rid==4:
        return "ap90"
    elif rid==5:
        return "ziff89-90"
    elif rid==6:
        return "ziff91-92"

def getQids(rid):
    if rid==1:
        return wsj_train_qids
    elif rid==2:
        return wsj_test_qids
    elif rid==3:
        return ap_train_qids
    elif rid==4:
        return ap_test_qids
    elif rid==5:
        return ziff_train_qids
    elif rid==6:
        return ziff_test_qids


def train_svm(rid, fbdoc, svddim, run_tag, nsample=None):
    oddp_tag = '_oddp' if '.oddp' in run_tag else ''
    prob_tag = ' -b 1 ' if '.oddp' not in run_tag else ' '
    nsample_tag = '.nsample.%d' % nsample if not nsample == None else ''
    train_qids = getQids(rid)
    train_qids.sort()
    svmname = None
    if train_qids[-1]-train_qids[0]+1 != len(train_qids):
        for index in xrange(len(train_qids)):
            if train_qids[index]-train_qids[0]!=index:
                svmname = '%s.q%d-%d-%d.%d.desc.fbdoc%d.svddim%d%s%s'%(getRunStr(rid), train_qids[0],train_qids[index],train_qids[-1], len(train_qids),fbdoc,svddim,run_tag,nsample_tag)
                break
    else:
        svmname = '%s.q%d-%d.%d.desc.fbdoc%d.svddim%d%s%s'%(getRunStr(rid), train_qids[0],train_qids[-1], len(train_qids),fbdoc,svddim,run_tag, nsample_tag)
    
    print svmname
    # read training examples
    ofilename = '../tmp/%s.train.svm'%svmname
    ofile=open(ofilename,'w')
    for qid in train_qids:
        mu = smallsets_mus[rid]
        ifilename = ''
        if run_tag == '' or run_tag == '.oddp':
            ifilename = '../smallsets_qtfs%s/%s.q%d.okw.desc.mu%d.fbdocs%d.svddim%d.svm'%(oddp_tag, getRunStr(rid), qid, mu, fbdoc, svddim)
        elif run_tag == '.rf' or run_tag == '.rf.oddp':
            ifilename = '../smallsets_qtfs%s/%s.q%d.okw.desc.fbdocs%d.svddim%d.rf.svm'%(oddp_tag, getRunStr(rid), qid, fbdoc, svddim)
        elif run_tag == '.resample' or run_tag == '.resample.oddp':
            ifilename = '../qtfs_linear%s/q%d.okw.desc.mu%d.fbdocs%d.svddim%d.nsample.%d.svm'%(oddp_tag, qid, mu, fbdoc, svddim, nsample)
        elif run_tag == '.reweighted':
            ifilename = '../qtfs_linear%s/q%d.okw.desc.mu%d.fbdocs%d.svddim%d.reweighted.svm'%(oddp_tag, qid, mu, fbdoc, svddim)
        
        # query term feature file not exist

        if not os.path.exists(ifilename):
            continue
            #os.system('./query_term_feature_gen %d ../res/t%d.okw.mu%d.res %d %d %s'%(qid, trecid, mu, fbdoc, svddim, ifilename))
        
        ifile=open(ifilename,'r')
        for line in ifile:
            ofile.write('%s\n'%line.strip())

        ifile.close()

    ofile.close()

    #rescale train files
    os.system('../libsvm-3.14/svm-scale -l -u -s ../tmp/%s.rescale.param %s > %s.rescale' % (svmname, ofilename, ofilename))

    #train svm on condor
    jobstr = '%s.%s'%(svmname, strftime('%Y%m%d'))
    jobname = '.jobs/' + jobstr + '.job'
    f = open(jobname, 'w')
    f.write('Universe = vanilla\n')
    f.write('initialdir = /bos/usr2/gzheng/TermRecall/src\n')
    f.write('executable = /opt/python27/bin/python\n')
    f.write('arguments = ../libsvm-3.14/tools/gridregression.py -out ../out/%s.out %s %s.rescale\n'%(svmname, prob_tag, ofilename))
#    f.write('arguments = cv_regression.py %s.rescale ../out_L1/%s.out\n'%(ofilename, svmname))
    f.write('output = .jobs/'+jobstr+'.out\n')
    f.write('log = .jobs/'+jobstr+'.log\n')
    f.write('error = .jobs/'+jobstr+'.err\n')
    f.write('queue\n')
    f.close()
    os.system('condor_submit '+ jobname)    

def best_svm_performance(rid, run_tag=''):
    if run_tag == '.resample' or run_tag == '.resample.oddp':
        for nsample in range(1,31):
            train_svm(train_qids, good_fbdocs[trecno], good_svddims[trecno], run_tag, nsample)
    else:
        for fbdoc in ([500] if run_tag == '.rf' or run_tag == '.rf.oddp' else smallsets_fbdocs):
            #    for fbdoc in range(10,101,10):
            for svddim in smallsets_svddims:
#            for svddim in [100,200]:
            #(svddims_resample if run_tag == '.resample' or run_tag == '.resample.oddp' else svddims):
                train_svm(rid, fbdoc, svddim, run_tag)

def call_main(argstr):
    args = argstr.split(' ')
    run_tag = ''
    rid = int(args[0])
    
    best_svm_performance(rid, run_tag)
