from Constants import *
import os
import subprocess
import glob
import math
import random

def getRunStr(rid):
    if rid==1:
        return "wsj87-91"
    elif rid==2:
        return "wsj87-91"
#        return "wsj92"
    elif rid==3:
        return "ap88-89"
    elif rid==4:
        return "ap88-89"
#        return "ap90"
    elif rid==5:
        return "ziff89-90"
    elif rid==6:
        return "ziff89-90"
#        return "ziff91-92"

def getQids(i):
    return range(1,i)+range(i+1,301)

def getTestQids(i):
    return [i];

def getBestFbdoc(rid):
    if rid==1:
        return 100
    elif rid==3:
        return 200
    elif rid==5:
#        return 100 # for SVD feature
#        return 300 # for PLSA feature
        return 200 # for PLSA and SVD feature

def getBestSvddim(rid):
    if rid==1:
        return 200
    elif rid == 3:
        return 100
    elif rid ==5:
        return 100

def eval_svm(rid, tid, run_tag, nsample=None):
    oddp_tag = '_oddp' if '.oddp' in run_tag else ''
    prob_tag = ' -b 1 ' if '.oddp' not in run_tag else ' '
    nsample_tag = '.nsample.%d' % nsample if not nsample == None else ''
    train_qids = getQids(tid)
    test_qids = getTestQids(tid)
    
    test_prf_flag = False
    if run_tag == '.rf.prf':
        test_prf_flag = True
        run_tag = '.rf'

    train_qids.sort()
    svmname = None
    if train_qids[-1]-train_qids[0]+1 != len(train_qids):
        for index in xrange(len(train_qids)):
            if train_qids[index]-train_qids[0]!=index:
                svmname = '%s.q%d-%d-%d.%d.desc.fbdoc???.svddim???%s%s'%(getRunStr(rid),train_qids[0],train_qids[index],train_qids[-1], len(train_qids), run_tag,nsample_tag)
                break
    else:
        svmname = '%s.q%d-%d.%d.desc.fbdoc???.svddim???%s%s'%(getRunStr(rid),train_qids[0],train_qids[-1], len(train_qids), run_tag, nsample_tag)

    svmname_prefix = svmname.split('.fbdoc')[0]

    # get the best result 
    svm_result_list = []
    for filename in glob.glob('../out/%s.out'%svmname):
        parts = filename.split('/')[-1].split('.')
        fbdoc = int(parts[4].split('fbdoc')[1])
        svddim = int(parts[5].split('svddim')[1])

#        if fbdoc not in fbdocs or svddim not in svddims:
#        if fbdoc not in [getBestFbdoc(rid)] or svddim not in [100]:
        if fbdoc not in [getBestFbdoc(rid)] or svddim not in [getBestSvddim(rid)]:
                continue
        
        r = open(filename, 'r')
        for line in r:
            splits = line.strip().split(' ')
            c = float(splits[0])
            g = float(splits[1])
            p = float(splits[2])
            mse = float(splits[3])
            svm_result_list.append((mse, (fbdoc, svddim, c, g, p)))
        r.close()
    
    svm_result_list.sort()
    best_fbdoc = svm_result_list[0][1][0]
    best_svddim = svm_result_list[0][1][1]
    best_c = 2**svm_result_list[0][1][2]
    best_g = 2**svm_result_list[0][1][3]
    best_p = 2**svm_result_list[0][1][4]

    # print best_fbdoc, best_svddim, best_c, best_g, best_p
    print ' CV_MSE:%f' %svm_result_list[0][0],

    # get test examples ready
    # create test samples every time
    # Note, different settings would overwite them!
    trainsvmname = '%s.fbdoc%d.svddim%d%s%s'%(svmname_prefix, best_fbdoc, best_svddim, run_tag, nsample_tag)

    # CHANGE HERE
    ofilename = '../tmp/%s.fbdoc%d.svddim%d%s%s.test.svm'%(svmname_prefix, best_fbdoc, best_svddim, run_tag, nsample_tag)
    ofile = open(ofilename, 'w')
    for qid in test_qids:
        mu = smallsets_mus[rid+1]
        ifilename = ''
        if run_tag == '' or run_tag == '.oddp':
            ifilename = '../smallsets_qtfs%s/%s.q%d.okw.desc.mu%d.fbdocs%d.svddim%d.svm'%(oddp_tag, getRunStr(rid+1), qid, mu, best_fbdoc, best_svddim)
        elif run_tag == '.rf' or run_tag == '.rf.oddp':
            if test_prf_flag:
                ifilename = '../smallsets_qtfs%s/%s.q%d.okw.desc.mu%d.fbdocs%d.svddim%d.svm'%(oddp_tag, getRunStr(rid+1), qid, mu, best_fbdoc, best_svddim)
            else:
                ifilename = '../smallsets_qtfs%s/%s.q%d.okw.desc.fbdocs%d.svddim%d.rf.svm'%(oddp_tag, getRunStr(rid+1), qid, best_fbdoc, best_svddim)
        elif run_tag == '.resample' or run_tag == '.resample.oddp':
            ifilename = '../qtfs_linear%s/q%d.okw.desc.mu%d.fbdocs%d.svddim%d.nsample.%d.svm'%(oddp_tag, qid, mu, best_fbdoc, best_svddim, nsample)
        elif run_tag == '.reweighted':
              ifilename = '../qtfs_linear%s/q%d.okw.desc.mu%d.fbdocs%d.svddim%d.reweighted.svm'%(oddp_tag, qid, mu, best_fbdoc, best_svddim)          
        
        # query term feature file not exist
        if not os.path.exists(ifilename):
            continue
            #os.system('./query_term_feature_gen %d ../res/t%d.okw.mu%d.res %d %d %s'%(qid, trecid, mu, fbdoc, svddim, ifilename))
        
        ifile=open(ifilename,'r')
        for line in ifile:
            ofile.write('%s\n'%line.strip())

        ifile.close()

    ofile.close()

    # rescale test files
    os.system('../libsvm-3.14/svm-scale -r ../tmp/%s.rescale.param %s > %s.rescale' % (trainsvmname, ofilename, ofilename))

    #train final svm
    os.system('../libsvm-3.14/svm-train -q -s 3 -c %f -g %f -p %f %s ../tmp/%s.train.svm.rescale ../tmp/%s.model' % (best_c, best_g, best_p, prob_tag, trainsvmname, trainsvmname))

    #test it!
    #os.system('../libsvm-3.14/svm-predict %s ../tmp/%s.test.svm.rescale ../tmp/%s.model ../tmp/%s.out' % (prob_tag, trainsvmname, trainsvmname, trainsvmname))
    #CHANGE HERE!
    svmtest_output = subprocess.check_output(('../libsvm-3.14/svm-predict%s%s.rescale ../tmp/%s.model ../tmp/%s.out' % (prob_tag, ofilename, trainsvmname, trainsvmname)).split(' '))
    current_mse = float(svmtest_output.strip().split('Mean squared error = ')[1].split(' ')[0])
    print 'MSE: '+str(current_mse),

    #generate biased query
    os.system('./wqg_biased ../tmp/%s.test.svm %f ../tmp/%s.biased.q'% (trainsvmname, math.sqrt(current_mse), trainsvmname))
    
    #generate true query
    os.system('./wqg_true_recall ../tmp/%s.test.svm ../tmp/%s.true.q'% (trainsvmname, trainsvmname))

    #generate weighted query
    # oddp
    if prob_tag == ' ':
        os.system('./wqg_oddP ../tmp/%s.test.svm ../tmp/%s.out ../tmp/%s.q'% (trainsvmname, trainsvmname, trainsvmname))
    # p
    else:
        os.system('./wqg_P ../tmp/%s.test.svm ../tmp/%s.out ../tmp/%s.q'% (trainsvmname, trainsvmname, trainsvmname))

    #NOTE HERE:
    #Test qids should be in the same trec dataset!!!

    #search the query!
    os.system('/bos/usr2/gzheng/.local/bin/IndriRunQuery /bos/tmp4/lezhao/gov2/queries/stoplist.param -count=1000 ../tmp/%s.q -index=/bos/tmp17/gzheng/indexes/%s -trecFormat=t -rule=method:d,mu:%d > ../smallsets_res/%s.res' %(trainsvmname, getRunStr(rid+1), smallsets_mus[rid+1], trainsvmname))
    
    #evaluate the results!
    eval_output = subprocess.check_output(('./trec_eval ../smallsets_qrels/%s.adhoc ../smallsets_res/%s.res' %(getRunStr(rid+1), trainsvmname)).split(' '))

    #search the biased query!
    os.system('/bos/usr2/gzheng/.local/bin/IndriRunQuery /bos/tmp4/lezhao/gov2/queries/stoplist.param -count=1000 ../tmp/%s.biased.q -index=/bos/tmp17/gzheng/indexes/%s -trecFormat=t -rule=method:d,mu:%d > ../smallsets_res/%s.biased.res' %(trainsvmname, getRunStr(rid+1), smallsets_mus[rid+1], trainsvmname))
    
    #evaluate the biased results!
    biased_output = subprocess.check_output(('./trec_eval ../smallsets_qrels/%s.adhoc ../smallsets_res/%s.biased.res' %(getRunStr(rid+1), trainsvmname)).split(' '))

    #search the groundtruth query!
    os.system('/bos/usr2/gzheng/.local/bin/IndriRunQuery /bos/tmp4/lezhao/gov2/queries/stoplist.param -count=1000 ../tmp/%s.true.q -index=/bos/tmp17/gzheng/indexes/%s -trecFormat=t -rule=method:d,mu:%d > ../smallsets_res/%s.true.res' %(trainsvmname, getRunStr(rid+1), smallsets_mus[rid+1], trainsvmname))
    
    #evaluate the groundtruth results!
    true_output = subprocess.check_output(('./trec_eval ../smallsets_qrels/%s.adhoc ../smallsets_res/%s.true.res' %(getRunStr(rid+1), trainsvmname)).split(' '))

    eval_map = eval_output.strip().split('\n')[5]
    true_map = true_output.strip().split('\n')[5]
    biased_map = biased_output.strip().split('\n')[5]
    true_map_f = float(true_map.split('\t')[-1])
    biased_map_f = float(biased_map.split('\t')[-1])
    print 'MAP: '+str(float(eval_map.split('\t')[-1])),
    print '   BEST_FBDOC:%d BEST_SVDDIM:%d BIASED_MAP:%f TRUE_MAP:%f' % (best_fbdoc, best_svddim, biased_map_f, true_map_f)

def eval_best_svm(rid, run_tag=''):
    if run_tag == '.resample' or run_tag == '.resample.oddp':
        for nsample in range(1,31):
            print '%s %d:'%(argstr, nsample),
            eval_svm(train_qids,  test_qids, run_tag, nsample)
    else:
        print getRunStr(rid)
#        for tid in range(51,301):
        for tid in range(118,301):
            print '%d ' % tid,
            eval_svm(rid, tid, run_tag)


def process(argstr):
    args = argstr.split(' ')
    run_tag = ''
#    run_tag = '.rf'
    rid = int(args[0])
    
    eval_best_svm(rid, run_tag)


#for rid in [1,3,5]:
for rid in [5]:
    process('%d'%(rid))


            
