from  xml.dom.minidom import *
import sys
import string
import os

def process_snippet(text):
    text = text.replace('&amp;', '&')
    text = text.replace('&amp;', '&')
    text = text.replace('&', ' ')

    text = text.replace('&lt;', ' ')
    text = text.replace('&gt;', ' ')
    text = text.replace('&quot;', ' ')

    exclude = set(string.punctuation)
    text = ''.join(ch for ch in text if ch not in exclude)
    text = ' '.join(text.split())

    return text

def process(query):
    # process puntuations
    query = query.replace('&amp;', ' ')
    query = query.replace('(', ' ')
    query = query.replace(')', ' ')
    query = query.replace('$', ' ')
    query = query.replace('\'', ' ')
    query = query.replace(".", " ")
    query = query.replace(",", " ")
    query = query.replace("*", " ")
    query = query.replace("?", " ")
    query = query.replace("!", " ")
    query = query.replace(':', ' ')

    parts = query.split('\"')
    if(len(parts)<=1):
        words = query.split(' ')
        word_list = []
        for word in words:
            if word.strip()!='':
                word_list.append(word.strip())

        return (query.strip(), word_list)
    
    out = ''
    word_list = []
            
    for part in parts:
        if part!='':
            if len(part.strip().split(' '))>1:
                # phrase may have multiple spaces in it, but it should be ok
                phrase = '#1(%s)'%part.strip()
                out+= ('%s '% phrase)
                word_list.append(phrase)
            else:
                out+=('%s ' %part.strip())
                word_list.append(part.strip())

    return (out.strip(), word_list)

if len(sys.argv) < 3:
    print 'Usage: %s <raw_query_xml> <output_dir>' % sys.argv[0]
    exit(0)
    
dom = parse(sys.argv[1])
outdir = sys.argv[2]

if outdir[-1]=='/':
    outdir = outdir[:-1]

runid = outdir.split('/')[-1]
print "RUNID: %s"%runid

sessions = dom.getElementsByTagName('session')
for session in sessions:
    session_num = session.getAttribute('num')
    print session_num,

    interactions = session.getElementsByTagName('interaction')
    intera_num = None
    print len(interactions)
    for interaction in interactions:
        docname_map = {}
        title_map = {}
        snippet_map = {}
        intera_num = interaction.getAttribute('num')
        #        print intera_num,':',
        
        results = interaction.getElementsByTagName('results')
        result_lists = results[0].getElementsByTagName('result')
        for result in result_lists:
            rank = int(result.getAttribute('rank'))
            docname = result.getElementsByTagName('clueweb09id')[0].childNodes[0].nodeValue
            docname_map[rank] = docname
            title = result.getElementsByTagName('title')[0].childNodes[0].nodeValue
            title_map[rank] = process_snippet(title)
            childnodes = result.getElementsByTagName('snippet')[0].childNodes
            snippet = None
            if childnodes == []:
                snippet = ''
            else:
                snippet = result.getElementsByTagName('snippet')[0].childNodes[0].nodeValue
                
            snippet_map[rank] = process_snippet(snippet)

        clicked = interaction.getElementsByTagName('clicked')
        clicked_lists = clicked[0].getElementsByTagName('click')
        
        docname_out = open('../clicks/%s/%s.%s.click.doc' %(runid, session_num, intera_num), 'w')
        snippet_out1 = open('../clicks/%s/%s.%s.click.t' %(runid, session_num, intera_num), 'w')
        snippet_out2 = open('../clicks/%s/%s.%s.click.s' %(runid, session_num, intera_num), 'w')
        snippet_out3 = open('../clicks/%s/%s.%s.click.ts' %(runid, session_num, intera_num), 'w')
        for click in clicked_lists:
            rank = int(click.getElementsByTagName('rank')[0].childNodes[0].nodeValue)
            docname_out.write('%s\n' % docname_map[rank])
            snippet_out1.write('%s\n' % title_map[rank])
            snippet_out2.write('%s\n' % snippet_map[rank])
            snippet_out3.write('%s %s\n' % (title_map[rank].strip(), snippet_map[rank].strip()))

        docname_out.close()
        snippet_out1.close()
        snippet_out2.close()
        snippet_out3.close()

        query = interaction.getElementsByTagName('query')
        query_str_unprocessed = query[0].childNodes[0].nodeValue
        print 'Unprocessed: %s' % query_str_unprocessed
        query_processed_result = process(query[0].childNodes[0].nodeValue)
        query_str = query_processed_result[0]
        
        out = open('%s/%s.%s.q'%(outdir, session_num, intera_num), 'w')
        out.write('<parameters>\n')
        out.write('  <query><type>indri</type><number>%s.%s</number><text>\n' %(session_num, intera_num))
        out.write('#combine(%s)\n'%query_str)
        out.write('  </text></query>\n')
        out.write('</parameters>\n')
        out.close()
        #print query_str
        '''
        dep_tmp = open('_dep_tmp_', 'w')
        dep_tmp.write('%s\n' % query_str_unprocessed)
        dep_tmp.close()
        '''

        phrase_out = None
        if 'st11' in outdir:
#            os.system('perl depparse.pl _dep_tmp_ > ../parses/st11/%s.%s.dep' % (session_num, intera_num))
            phrase_out = open('../parses/st11/%s.%s.phrase' %(session_num, intera_num), 'w')
        elif 'st12' in outdir:
            phrase_out = open('../parses/st12/%s.%s.phrase' %(session_num, intera_num), 'w')
#            os.system('perl depparse.pl _dep_tmp_ > ../parses/st12/%s.%s.dep' % (session_num, intera_num))
        for word in query_processed_result[1]:
            phrase_out.write('%s\n' % word)

        print 'Reformulation: %s' % query_str, query_processed_result[1]
        phrase_out.close()

    currentquery = session.getElementsByTagName('currentquery')
    current_query = currentquery[0].getElementsByTagName('query')
    current_query_str_unprocessed = current_query[0].childNodes[0].nodeValue
    print 'Unprocessed: %s' % current_query_str_unprocessed
    current_query_processed_result = process(current_query[0].childNodes[0].nodeValue)
    current_query_str = current_query_processed_result[0]

    out = open('%s/%s.q'%(outdir, session_num), 'w')
    out.write('<parameters>\n')
    out.write('  <query><type>indri</type><number>%s</number><text>\n' %(session_num))
    out.write('#combine(%s)\n'%current_query_str)
    out.write('  </text></query>\n')
    out.write('</parameters>\n')
    out.close()
    '''
    dep_tmp = open('_dep_tmp_', 'w')
    dep_tmp.write('%s\n' % current_query_str_unprocessed)
    dep_tmp.close()
    '''
    
    current_phrase_out = None
    if 'st11' in outdir:
        current_phrase_out = open('../parses/st11/%s.phrase' %(session_num), 'w')
#        os.system('perl depparse.pl _dep_tmp_ > ../parses/st11/%s.dep' % (session_num))
    elif 'st12' in outdir:
        current_phrase_out = open('../parses/st12/%s.phrase' %(session_num), 'w')
#        os.system('perl depparse.pl _dep_tmp_ > ../parses/st12/%s.dep' % (session_num))

    for word in current_query_processed_result[1]:
        current_phrase_out.write('%s\n' % word)

    current_phrase_out.close()
    print 'Current: %s' % current_query_str, current_query_processed_result[1]





