import os
import glob
import sys

def getQids(runid):
    if runid == 'st11':
        return range(1, 77)
    elif runid == 'st12':
        return range(1, 99)

def getSnippetSuffix(num):
    if num==1:
        return 's'
    elif num==2:
        return 't'
    elif num==3:
        return 'ts'

if len(sys.argv) < 2 :
    print "Usage: %s \"st11|st12\"" % sys.argv[0]
    exit(1)

runid = sys.argv[1]
qids = getQids(runid)

fbdocs = [200]
svddims = [150]

for qid in qids:
    mu = 4000
    for fbdoc in fbdocs:
        for svddim in svddims:
            res_files = glob.glob('../clueweb09_res/%s/q%d.*mu%d*'%(runid,qid,mu))
                
            # start from 1
            for snippet in [1,2,3]:
                for subqid in range(1, len(res_files)):
                    filename = '../sessiontrack_click_qtfs%d/%s.q%d.%d.okw.mu%d.fbdocs%d.svddim%d.svm'%(snippet, runid, qid, subqid, mu, fbdoc, svddim)
                    res_file = None
                    qrel = '../qrels/qrels.%s.txt' % runid
                    res_file = '../clueweb09_res/%s/q%d.%d.okw.mu%d.res'%(runid,qid,subqid,mu)
                    click_doc = '../clicks/%s/%d.%d.click.doc'%(runid, qid, subqid)
                    snippet_file = '../clicks/%s/%d.%d.click.%s'%(runid, qid, subqid, getSnippetSuffix(snippet))
                    
                    if not os.path.exists(filename):
                        print filename
                        jobstr = '%s.q%d.%d.okw.mu%d.fbdocs%d.svddim%d.%d.svm'%(runid, qid, subqid, mu, fbdoc, svddim, snippet)
                        jobname = ".jobs/"+jobstr+".job"
                        f = open(jobname, "w")
                        f.write("Universe = vanilla\n")
                        f.write("initialdir = /bos/usr2/gzheng/TermRecall/src\n")
                        f.write("executable = sessiontrack_click_qtf_gen\n")
                        f.write("arguments = " + str(qid) + " " + res_file + " ../parses/"+runid+"/"+str(qid)+".dep " + qrel + " " + str(fbdoc) + " " + str(svddim) + " "+click_doc+" " + snippet_file + " " + filename+"\n")
                        f.write("output = .jobs/"+jobstr+".out\n")
                        f.write("log = .jobs/"+jobstr+".log\n")
                        f.write("error = .jobs/"+jobstr+".err\n")
                        f.write("queue\n")
                        f.close()
                        os.system("condor_submit "+ jobname)            
                    

                    
