import os
from query_term_feature_le import *
from condor_cv_svm import prepare_svm_file
from time import strftime

def tid2range(tid):
    if tid==35:
        return range(151, 301)
    if tid==37:
        return range(151, 401)
    if tid==39:
        return range(151, 501)

    if tid==13 or tid==14:
        tid+=1

    return range(tid*50+1, tid*50 + 51)

def get_test_tid(tid):
    if tid==35:
        return 6
    if tid==37:
        return 8
    if tid==39:
        return 10
    else:
        return tid+1

params = []
for w_t in range(0,101,5):
    for w_b in range(0,101,5):
        if w_t + w_b <= 100:
            w_u = 100 - w_t - w_b
            params.append((float(w_t)/100, float(w_b)/100, float(w_u)/100))

params = [(0.33, 0.33, 0.33)]

for trecno in range(3,13,2) + [35, 37,39]:
    test_tid = get_test_tid(trecno)
    test_qids = tid2range(test_tid)
    
    mu = 900
    if test_tid ==9 or test_tid == 10:
        mu = 1500

    for fbdoc in getFbdocs(test_tid, mu):
        # for true data one fbdoc is OK
        for svddim in [150]:
            test_svm_filename = 'q%d-%d.%d.desc.fbdoc%d.svddim%d.train.svm' % (test_qids[0], test_qids[-1], len(test_qids), fbdoc, svddim)
            for param in params:
                os.system('/opt/python27/bin/python2.7 wqg_true_recall_sdm.py ../tmp/%s ../tmp/%s.true.%f.%f.%f.q %f %f %f' % (test_svm_filename,test_svm_filename, param[0], param[1], param[2], param[0], param[1], param[2]))
                
                jobstr = '%s.%f.%f.%f.%s' %(test_svm_filename, param[0], param[1], param[2], strftime('%Y%m%d'))
                jobname = '.jobs/' + jobstr + '.job'
                f = open(jobname, 'w')
                f.write('Universe = vanilla\n')
                f.write('initialdir = /bos/usr2/gzheng/TermRecall/src\n')
                f.write('executable = /opt/python27/bin/python\n')
                f.write('arguments = ./sweep_true_sdm_condor.py ../tmp/%s.true.%f.%f.%f.q %d\n'%(test_svm_filename, param[0], param[1], param[2], test_tid))
                f.write('output = .jobs/'+jobstr+'.out\n')
                f.write('log = .jobs/'+jobstr+'.log\n')
                f.write('error = .jobs/'+jobstr+'.err\n')
                f.write('queue\n')
                f.close()
                os.system('condor_submit '+ jobname)    
        break

