import sys

def oddp2p(oddp):
    if oddp< 0.01:
        return 0.01
    return oddp/ (oddp+1.0)


if (len(sys.argv) != 4):
    print 'Usage: %s <test.svm> <test.out> <test.q>' % sys.argv[0]
    exit(0)

svm_test=sys.argv[1]
svm_out = sys.argv[2]
query_output = open(sys.argv[3], 'w')

pre_qid = -1
query_output.write('<parameters>\n')

d=dict()

with open(svm_test, 'r') as f1, open(svm_out, 'r') as f2:
    for line in zip(f1, f2):
        feature = line[0].strip()
        output = line[1].strip()
        qid = int(feature.split('\t')[-1])
        term = feature.split('\t')[-2]
        prediction = float(output)
        prob = oddp2p(prediction)
        d[term]=prob
        
        if qid != pre_qid:
            if pre_qid != -1:
                query_output.write(' )\n')
                query_output.write('\t</text></query>\n')
                

            for term in d:
                if term.startswith('#1'):
                    part = term.split('#1(')[-1].split(')')[0]
                    uw_term = '#uw8(%s)' % part
                    if uw_term in d:
                        d[uw_term] = d[uw_term] + d[term]
                    else:
                        d[uw_term] = d[term]

            for uw8 in d:
                if uw8.startswith('#uw8'):
                    parts = uw8.split('#uw8(')[-1].split(')')[0].split(' ')
                    for part in parts:
                        term = part.strip()
                        if term in d:
                            d[term] = d[term] + d[uw8]
                        #else:
                        #    d[term] = d[uw8]

            query_output.write('\t<query><type>indri</type><number>%d</number><text>\n' % qid)
            query_output.write('#weight( ')

            for term in d:
                if not term.startswith('#'):
                    query_output.write('%f %s ' % (d[term], term))

            for bi in d:
                if bi.startswith('#1'):
                    query_output.write('%f %s ' % (d[bi], bi))

            for uw in d:
                if uw.startswith('#uw'):
                    query_output.write('%f %s ' % (d[uw], uw))
                    
            d.clear()
            pre_qid = qid


if pre_qid!=1:
    query_output.write(' )\n')
    query_output.write('\t</text></query>\n')
    query_output.write('</parameters>\n')

query_output.close()

    
