import sys
from collections import defaultdict

def oddp2p(oddp):
#    if oddp< 0.01:
#    return 0.01
    return oddp/ (oddp+1.0)


if (len(sys.argv) != 6):
    print 'Usage: %s <test.svm> <test.q> <w_t> <w_b> <w_u>' % sys.argv[0]
    exit(0)

svm_test=sys.argv[1]
query_output = open(sys.argv[2], 'w')
w_t = float(sys.argv[3])
w_b = float(sys.argv[4])
w_u = float(sys.argv[5])




d=defaultdict(list)
qids=set()

with open(svm_test, 'r') as f1:
    for line in f1:
        qid = line.strip().split('\t')[-1]
        qids.add(int(qid))
        part = line.strip().split('\t')[-2]
        true_oddp = float(line.strip().split(' ')[0])
        true_p = oddp2p(true_oddp)
#        print qid, part, oddp2p(true_oddp)
    
        if not part.startswith('#'):
            d[qid+'_t'].append((part, true_p))

        elif part.startswith('#1'):
            d[qid+'_b'].append((part, true_p))
        else:
            d[qid+'_u'].append((part, true_p))


sorted(qids)

query_output.write('<parameters>\n')
for qid in qids:
    query_output.write('\t<query><type>indri</type><number>%d</number><text>\n' % qid)
    query_output.write('#weight(\n')

    #term
    if len(d['%d_t' % qid]) > 0 and w_t > 0:
        query_output.write('         %f #weight( ' % w_t)

        for item in d['%d_t' % qid]:
            query_output.write('%f %s ' % (item[1], item[0]))

        query_output.write(')\n')

    # bigram
    if len(d['%d_b' % qid]) > 0 and w_b > 0:
        query_output.write('         %f #weight( ' % w_b)

        for item in d['%d_b' % qid]:
            query_output.write('%f %s ' % (item[1], item[0]))

        query_output.write(')\n')

    # unordered
    if len(d['%d_u' % qid]) > 0 and w_u > 0:
        query_output.write('         %f #weight( ' % w_u)

        for item in d['%d_u' % qid]:
            query_output.write('%f %s ' % (item[1], item[0]))

        query_output.write(')\n')

    
    query_output.write(' )\n')
    query_output.write('\t</text></query>\n')
    
query_output.write('</parameters>\n')

query_output.close()
