import sys
import glob
from collections import defaultdict
from random import randint

def oddp2p(oddp):
    return oddp / (oddp+1.0)

def bychance(p):
    r = randint(1,100)
    threshold = 100 * p;
    if r <= threshold:
        return True
    else:
        return False


if (len(sys.argv) != 5):
    print 'Usage: %s <qid_start> <qid_end> <qtf_dir> <query_output_file>' % sys.argv[0]
    print '       [qid_start, qid_end], inclusive'
    exit(0)

qid_start = int(sys.argv[1])
qid_end = int(sys.argv[2])
qtfs_dir = sys.argv[3]

query_output = open(sys.argv[4], 'w')


query_output.write('<parameters>\n')
for qid in range(qid_start, qid_end +1):
    query_output.write('\t<query><type>indri</type><number>%d</number><text>\n' % qid)
    query_output.write('#weight(\n')

    query_part_list1 = []
    query_part_list2 = []
    sum1 = 0;
    sum2 = 0;
    for filename in glob.glob('%s/q%d*.true.recall'%(qtfs_dir, qid)): # should return a list of same files with different fbdoc and svddim and take the first one
        count = 0
        with open(filename, 'r') as qid_in:
            for line in qid_in:
                parts = line.split('#', 1)
                oddp = float(parts[0])
                p = oddp2p(oddp)
                query_expr = parts[1].split('\t')[1]

                '''
                count += 1
                if count % 2 == 0:
                    query_output.write('\t%f %s\n' % (min(p+0.01,1), query_expr))
                else:
                    query_output.write('\t%f %s\n' % (max(p-0.01, 0.001), query_expr))
                    

                '''
                '''
                # 0.8 true, 0.1 +0.01, 0.1 -0.01
                r = randint(1,100)
                if r <= 20:
                    if r <= 10:
                        query_output.write('\t%f %s\n' % (min(p+0.01,1), query_expr))
                    else:
                        query_output.write('\t%f %s\n' % (max(p-0.01, 0.001), query_expr))
                else:
                    query_output.write('\t%f %s\n' % (p, query_expr))
                    '''

                if bychance(0.5):
                    query_part_list1.append((query_expr, p))
                    sum1 += p
                else:
                    query_part_list2.append((query_expr, 0.5))
                    sum2 += 0.5
                
#                query_part_list.append((query_expr, p))
        break
 
    query_output.write('\t%f #weight(\n' % 0.5)
    for pair in query_part_list1:
        query_output.write('\t\t%f %s\n' % (pair[1], pair[0]))
    query_output.write('\t)\n')
    query_output.write('\t%f #weight(\n' % 0.5)
    for pair in query_part_list2:
        query_output.write('\t\t%f %s\n' % (pair[1], pair[0]))
    query_output.write('\t)\n')
#    for i in range(0, len(query_part_list) -1):
#        for j in range(i+1, len(query_part_list)):
#            query_output.write('\t#weight(%f %s %f %s)\n' % (query_part_list[i][1], query_part_list[i][0], query_part_list[j][1], query_part_list[j][0]))
        
    query_output.write(' )\n')
    query_output.write('\t</text></query>\n')
    
query_output.write('</parameters>\n')

query_output.close()
